#include "stdafx.h"

#include <commdlg.h>
#include <commctrl.h>
#include <windowsx.h>
#include <prsht.h>
#include <shlwapi.h>
#include <sys/stat.h>

#include "resource.h"
#include "zip.h"
#include "unzip.h"
#include "Util.h"
#include "Logger.h"
#include "BrowseBeckyFolderDlg2.h"
#include "SettingDialog.h"

////////////////////////////////////////////////////////////////////////
// }N
////////////////////////////////////////////////////////////////////////

#define SET_WINDOW_TEXT(hWnd_, id_, text_) do { \
	HWND item_ = GetDlgItem((hWnd_), (id_)); \
	SetWindowText(item_, (text_)); \
} while (false)

#define GET_WINDOW_TEXT(hWnd_, id_, refstr_) do { \
	HWND item_ = GetDlgItem((hWnd_), (id_)); \
	std::vector<char> buffer_; \
	int length_ = GetWindowTextLength(item_); \
	buffer_.resize(length_ + 1); \
	GetWindowText(item_, &buffer_[0], length_ + 1); \
	*(refstr_) = std::string(&buffer_[0], length_); \
} while (false)

#define SET_CHECK(hWnd_, id_, bCheck_) do { \
	HWND item_ = GetDlgItem((hWnd_), (id_)); \
	SendMessage(item_, BM_SETCHECK, (bCheck_) ? BST_CHECKED : BST_UNCHECKED, 0); \
} while (false)

#define IS_CHECKED(hWnd_, id_) (SendMessage(GetDlgItem((hWnd_), (id_)), BM_GETCHECK, 0, 0) == BST_CHECKED)

#define ENABLE_WINDOW(hWnd_, id_, bEnable_) do { \
	HWND item_ = GetDlgItem((hWnd_),  (id_)); \
	EnableWindow(item_, (bEnable_) ? TRUE : FALSE); \
} while (false)

#define MAKE_OPENFILENAME_FILTER(pstrFilter) do { \
	std::string filterSeparator_; \
	filterSeparator_.push_back('\0'); \
	Util::Replace(*(pstrFilter), "|", filterSeparator_); \
} while (false)

#define SELECT_LISTVIEW(listCtrl_, index_) do { \
	ListView_SetItemState(listCtrl_, index_, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED); \
	ListView_EnsureVisible(listCtrl_, index_, FALSE); \
} while (false)

//----------------------------------------------------------------------
// Xgwb_ɖݒ肷
//----------------------------------------------------------------------

static void SetSortArrow(HWND listCtrl, int columnIndex, bool bAscending, HBITMAP bmUpArrow, HBITMAP bmDownArrow)
{
	// RRg[̃o[W𓾂B
	static bool isCommonCtrlVersion6 = Util::IsCommonCtrlVersion6();

	//
	// w肳ꂽJɃ\[gݒ肷ƂƂɁAȊÕJ̖OB
	//
	// wb_Rg[̃nh𓾂
	HWND listHdr = ListView_GetHeader(listCtrl);

	int itemCount = Header_GetItemCount(listHdr);
	for (int i = 0; i < itemCount; ++i) {

		HDITEM hdItem;
		ZeroMemory(&hdItem, sizeof(hdItem));

		// l擾
		hdItem.mask = HDI_FORMAT | (isCommonCtrlVersion6 ? 0 : HDI_BITMAP);
		Header_GetItem(listHdr, i, &hdItem);

		if (i == columnIndex) {
			//
			// ݒ肷B
			//
			if (isCommonCtrlVersion6) {
				// RRg[̃o[W 6 ȍ~̏ꍇ

				// tOݒ肵ȂB
				hdItem.fmt &= ~(HDF_SORTDOWN | HDF_SORTUP);
				hdItem.fmt |= (bAscending) ? HDF_SORTUP : HDF_SORTDOWN;
			} else {
				// RRg[̃o[W 6 Ȍꍇ

				// rbg}bvݒ肷B
				hdItem.fmt |= HDF_BITMAP | HDF_BITMAP_ON_RIGHT;
				hdItem.hbm = (bAscending) ? bmUpArrow : bmDownArrow;
			}

		} else {
			//
			// ̐ݒOB
			//
			if (isCommonCtrlVersion6) {
				// RRg[̃o[W 6 ȍ~̏ꍇ

				// tO𗎂ƂB
				hdItem.fmt &= ~(HDF_SORTDOWN | HDF_SORTUP);
			} else {
				// RRg[̃o[W 6 Ȍꍇ

				// tO𗎂ƂB
				hdItem.mask &= ~HDI_BITMAP;
				hdItem.fmt &= ~(HDF_BITMAP | HDF_BITMAP_ON_RIGHT);
			}
		}

		Header_SetItem(listHdr, i, &hdItem);
	}
}

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CBkBsfilSettingDialogProc::CBkBsfilSettingDialogProc(SettingDialogParam& param) :
	m_param(param)
{
	m_dlgCaption[0] = '\0';
}

//----------------------------------------------------------------------
// BkBsfilWrapper ̐ݒs_CAOvV[W
//----------------------------------------------------------------------

BOOL CBkBsfilSettingDialogProc::DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_MSG(hWnd, WM_INITDIALOG, OnInitDialog);
	HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
	HANDLE_MSG(hWnd, WM_NOTIFY, OnNotify);
	}

	return FALSE;
}

//----------------------------------------------------------------------
// WM_INITDIALOG nh
//----------------------------------------------------------------------

BOOL CBkBsfilSettingDialogProc::OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	//
	// vpeBV[g𒆉ɕ\
	//

	HWND hWndProp = GetParent(hWnd);		// vpeBV[g
	HWND hWndParent = GetParent(hWndProp);

	Util::CenterWindow(hWndParent, hWndProp);

	//
	// s
	//

	// _CAÕ^Cg擾Ă
	GetWindowText(hWnd, m_dlgCaption, sizeof(m_dlgCaption));

	// spam Ɣ肳ꂽ[̏u
	switch (m_param.bkProfile.GetProcSpam()) {
	case BkBsfilProfile::NoMove:
		SET_CHECK(hWnd, IDC_RADIO_NO_MOVE, TRUE);
		break;
	case BkBsfilProfile::GoFolder:
		SET_CHECK(hWnd, IDC_RADIO_GO_FOLDER, TRUE);
		break;
	case BkBsfilProfile::AddHeader:
		SET_CHECK(hWnd, IDC_RADIO_ADD_HEADER, TRUE);
		break;
	case BkBsfilProfile::GoTrash:
	default:
		SET_CHECK(hWnd, IDC_RADIO_GO_TRASH, TRUE);
		break;
	}

	// uwtH_ցv̏ꍇ̃tH_
	// \擾ĕ\
	const char* pDisplayName = m_param.pbka->GetFolderDisplayName(m_param.bkProfile.GetSpamFolder().c_str());
	if (pDisplayName && 0 < strlen(pDisplayName)) {
		SET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_FOLDER, pDisplayName);
	} else {
		SET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_FOLDER, "");

		// \擾łȂꍇ́AړtH_̏Zbg
		m_param.bkProfile.SetSpamFolder("");
	}
	ENABLE_WINDOW(hWnd, IDC_EDIT_SPAM_FOLDER, m_param.bkProfile.GetProcSpam() == BkBsfilProfile::GoFolder);

	// utH_Iv{^̗L/ݒ肷
	ENABLE_WINDOW(hWnd, IDC_BUTTON_SEL_SPAM_FOLDER, m_param.bkProfile.GetProcSpam() == BkBsfilProfile::GoFolder);

	// tH_ֈړꍇɊe[{bNX̓ʒũtH_Ɉړ
	SET_CHECK(hWnd, IDC_CHECK_SAME_RELATIVE_FOLDER_PATH, m_param.bkProfile.GetGoFolderSameRelativeFolderPath());
	ENABLE_WINDOW(hWnd, IDC_CHECK_SAME_RELATIVE_FOLDER_PATH, m_param.bkProfile.GetProcSpam() == BkBsfilProfile::GoFolder);

	// uwb_tv̏ꍇ̃wb_
	SET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_NAME, m_param.bkProfile.GetSpamHeaderFieldName().c_str());
	SET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_BODY, m_param.bkProfile.GetSpamHeaderFieldBody().c_str());

	//ENABLE_WINDOW(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_NAME, m_param.bkProfile.GetProcSpam() == BkBsfilProfile::AddHeader);
	//ENABLE_WINDOW(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_BODY, m_param.bkProfile.GetProcSpam() == BkBsfilProfile::AddHeader);
	ENABLE_WINDOW(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_NAME, TRUE);
	ENABLE_WINDOW(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_BODY, TRUE);

	// spam Ɣ肳ꂽ[͊ǂɂ
	SET_CHECK(hWnd, IDC_CHECK_SET_READ_TO_SPAM_MAIL, m_param.bkProfile.GetSetReadToSpamMail());

	// N bsfilter f[^x[XQƂȂ
	SET_CHECK(hWnd, IDC_CHECK_DONT_CHECK_DB_ON_START, m_param.bkProfile.GetDontCheckDbOnStart());

	// OɃbZ[W{bNX\Ȃ
	SET_CHECK(hWnd, IDC_CHECK_DISABLE_BEFORE_MSGBOX, m_param.bkProfile.GetDisableBeforeMsgbox());

	// ʕ\̃bZ[W{bNX\Ȃ
	SET_CHECK(hWnd, IDC_CHECK_DISABLE_RESULT_MSGBOX, m_param.bkProfile.GetDisableResultMsgbox());

	// MɑMzCgXgɒǉ
	SET_CHECK(hWnd, IDC_CHECK_ADD_TO_ADDR_TO_WHITELIST_ONSEND, m_param.bkProfile.GetAddToAddrToWhiteListOnSend());

	// 莞у[wK clean ȃ[ spam wb_Ȃ
	SET_CHECK(hWnd, IDC_CHECK_DONT_REMOVE_SPAM_HEADER, m_param.bkProfile.GetDontRemoveSpamHeader());

	// 莞у[wK spam ȃ[zCgXg珜
	SET_CHECK(hWnd, IDC_CHECK_REMOVE_SPAM_FROM_WHITELIST, m_param.bkProfile.GetRemoveSpamFromWhiteList());


	// bsfilter ̐ݒt@C
	SET_WINDOW_TEXT(hWnd, IDC_EDIT_BSFILCONF, m_param.bsfilterConfig.c_str());

	// ݒ肷
	std::string bsfilterDesc = CResourceManager::FormatResourceString(IDS_BSFILTER_DESCRIPTION);
	SET_WINDOW_TEXT(hWnd, IDC_EDIT_BSFILTER_DESC, bsfilterDesc.c_str());

	return TRUE;
}

//----------------------------------------------------------------------
// WM_COMMAND nh
//----------------------------------------------------------------------

void CBkBsfilSettingDialogProc::OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify)
{
	switch (idCtl) {
	case IDC_BUTTON_SEL_SPAM_FOLDER:
		{
			//
			// spam Ɣ肳ꂽ[̈ړtH_I
			//

			char selFolder[MAX_PATH * 4];
			selFolder[0] = '\0';
			if (0 < m_param.bkProfile.GetSpamFolder().length()) {
				// ÕtH_IĂB
				// AO̐ݒ莞ƍŁAJg̃[{bNXςĂA
				// ݂tH_폜ĂꍇȂǂ́AYtH_͑IȂB
				_snprintf(selFolder, sizeof(selFolder), "%s%s", m_param.bkaDataFolder.c_str(), m_param.bkProfile.GetSpamFolder().c_str());
				FORCE_ASCIZ(selFolder);
			}

			// _CAO\A[{bNXI
			// NOTE: tH_Î߂̃[gtH_ Becky!̃f[^tH_ Ƃ
			CBrowseBeckyFolderDlg2 bkFolderDlg(m_param.pbka);
			std::string selFolderTitle = CResourceManager::FormatResourceString(IDS_CAPTION_SELECT_SPAM_FOLDER);
			int rcdlg = bkFolderDlg.DoModal(hWnd, m_param.bkaDataFolder.c_str(), selFolder, selFolderTitle.c_str());
			if (rcdlg != IDOK) {
				break;
			}

			std::string folderPath = bkFolderDlg.GetFolderPath();

			// ΃pX̃f[^tH_菜
			// [Becky!̃f[^tH_]\XXXXXXXX.mb\XXX  XXXXXXXX.mb\XXX oB

			std::string spamFolder;
			std::string message;

			int rootlength = m_param.bkaDataFolder.length();
			if (_strnicmp(m_param.bkaDataFolder.c_str(), folderPath.c_str(), rootlength) == 0) {

				spamFolder = &folderPath.c_str()[rootlength];
				spamFolder += "\\";

			} else {
				message = CResourceManager::FormatResourceString(IDS_MSG_COULD_NOT_GET_FOLDER);
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONERROR);
				break;
			}

			// tH_w肳Ă邩`FbN
			if (!Util::IsValidBeckyFolder(spamFolder)) {
				message = CResourceManager::FormatResourceString(IDS_MSG_SELECT_FOLDER);
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
				break;
			}

			// \擾ĕ\
			const char* pDisplayName = m_param.pbka->GetFolderDisplayName(spamFolder.c_str());
			if (!pDisplayName || strlen(pDisplayName) == 0) {
				message = CResourceManager::FormatResourceString(IDS_MSG_COULD_NOT_GET_DISPLAY_NAME_OF_FOLDER);
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONERROR);
				break;
			}
			SET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_FOLDER, pDisplayName);

			// ړtH_̏ݒ肷
			m_param.bkProfile.SetSpamFolder(spamFolder);
		}
		break;

	case IDC_RADIO_GO_FOLDER:	// tH_w肷
	case IDC_RADIO_GO_TRASH:	// ݔ
	case IDC_RADIO_NO_MOVE:	// ړȂ
	case IDC_RADIO_ADD_HEADER:	// wb_t
		{
			BOOL bGoFolder = IS_CHECKED(hWnd, IDC_RADIO_GO_FOLDER);

			ENABLE_WINDOW(hWnd, IDC_EDIT_SPAM_FOLDER, bGoFolder);
			ENABLE_WINDOW(hWnd, IDC_BUTTON_SEL_SPAM_FOLDER, bGoFolder);
			ENABLE_WINDOW(hWnd, IDC_CHECK_SAME_RELATIVE_FOLDER_PATH, bGoFolder);

			//BOOL bAddHeader = IS_CHECKED(hWnd, IDC_RADIO_ADD_HEADER);
			//ENABLE_WINDOW(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_NAME, bAddHeader);
			//ENABLE_WINDOW(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_BODY, bAddHeader);
		}
		break;

	case IDC_BUTTON_EDIT_BSFILCONF:	// ҏW
		{
			char executer[MAX_PATH * 4] = "";

			//
			// ł邾֘AtꂽAvP[VŋN
			//
			do {

				DWORD length = 0;
				HRESULT hr;

				if (GetKeyState(VK_CONTROL) < 0) {
					// Rg[L[Ăꍇ̂݁A֘AtꂽAvP[VgB

					//length = sizeof(executer);
					//hr = AssocQueryString(ASSOCF_NOTRUNCATE, ASSOCSTR_EXECUTABLE, ".conf", "open", executer, &length);
					//if (SUCCEEDED(hr) && 0 < length) {
					//	break;
					//}

					length = sizeof(executer);
					hr = AssocQueryString(ASSOCF_NOTRUNCATE, ASSOCSTR_EXECUTABLE, ".txt", "open", executer, &length);
					if (SUCCEEDED(hr) && 0 < length) {
						break;
					}
				}

				// ֘At񂪓Ȃꍇ̓g
				strcpy(executer, "notepad.exe");

			} while (false);

			char command[MAX_PATH * 4];
			_snprintf(command, sizeof(command), "\"%s\" \"%s\"", executer, m_param.bsfilterConfig.c_str());
			FORCE_ASCIZ(command);

			STARTUPINFO si;
			PROCESS_INFORMATION pi;

			ZeroMemory(&si, sizeof(si));
			si.cb = sizeof(si);
			ZeroMemory(&pi, sizeof(pi));

			CreateProcess(
					0, command,
					0, 0,
					TRUE,
					CREATE_DEFAULT_ERROR_MODE | CREATE_NEW_PROCESS_GROUP,
					0, m_param.dataFolder.c_str(),
					&si, &pi
						);

			CloseHandle(pi.hProcess);
			CloseHandle(pi.hThread);
		}
		break;

	case IDC_BUTTON_BSFIL_RESTORE:
		{
			// bsfilter f[^x[XXgA

			// t@C𓾂
			char filepath[MAX_PATH * 4];
			_snprintf(filepath, sizeof(filepath), "bsfilterdb_*.zip");
			FORCE_ASCIZ(filepath);

			std::string strFilter = CResourceManager::FormatResourceString(IDS_RESTORE_BSFILTER_FILE_FILTER);
			MAKE_OPENFILENAME_FILTER(&strFilter);
			std::string strTitle = CResourceManager::FormatResourceString(IDS_RESTORE_BSFILTER_DB_TITLE);
			std::string strDefExt = CResourceManager::FormatResourceString(IDS_RESTORE_BSFILTER_FILE_DEF_EXT);

			OPENFILENAME ofn;
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hWnd;
			ofn.lpstrFilter = strFilter.c_str();
			ofn.nFilterIndex = 1;
			ofn.lpstrFile = filepath;
			ofn.nMaxFile = sizeof(filepath);
			ofn.lpstrTitle = strTitle.c_str();
			ofn.Flags = OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
			ofn.lpstrDefExt = strDefExt.c_str();

			BOOL rc = GetOpenFileName(&ofn);
			if (!rc) {
				break;
			}

			CWaitCursor waitCursor;

			// f[^x[XXgA
			std::list<std::string> fileList;
			bool bSuccess = RestoreBsfilterResource(filepath, fileList);

			waitCursor.Restore();

			if (!bSuccess) {
				std::string message = CResourceManager::FormatResourceString(IDS_MSG_FAILED_TO_RESTORE_BSFILTER_DATABASE);
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONERROR);
			} else {
				std::string restoreTitle = CResourceManager::FormatResourceString(IDS_MSG_RESTORE_THERE_FILES, m_param.dataFolder.c_str());

				std::string message = restoreTitle;
				for (std::list<std::string>::iterator it = fileList.begin(); it != fileList.end(); ++it) {
					message += *it;
					message += "\r\n";
				}

				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
			}
		}
		break;

	case IDC_BUTTON_BSFIL_BACKUP:
		{
			// bsfilter f[^x[XobNAbv

			// t@C𓾂

			SYSTEMTIME systime = { 0 };
			GetLocalTime(&systime);

			char filepath[MAX_PATH * 4];
			_snprintf(filepath, sizeof(filepath), "bsfilterdb_%04d%02d%02d_%02d%02d%02d.zip",
				systime.wYear,
				systime.wMonth,
				systime.wDay,
				systime.wHour,
				systime.wMinute,
				systime.wSecond
			);
			FORCE_ASCIZ(filepath);

			std::string strFilter = CResourceManager::FormatResourceString(IDS_BACKUP_BSFILTER_FILE_FILTER);
			MAKE_OPENFILENAME_FILTER(&strFilter);
			std::string strTitle = CResourceManager::FormatResourceString(IDS_BACKUP_BSFILTER_DB_TITLE);
			std::string strDefExt = CResourceManager::FormatResourceString(IDS_BACKUP_BSFILTER_FILE_DEF_EXT);

			OPENFILENAME ofn;
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hWnd;
			ofn.lpstrFilter = strFilter.c_str();
			ofn.nFilterIndex = 1;
			ofn.lpstrFile = filepath;
			ofn.nMaxFile = sizeof(filepath);
			ofn.lpstrTitle = strTitle.c_str();
			ofn.Flags = OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
			ofn.lpstrDefExt = strDefExt.c_str();

			BOOL rc = GetSaveFileName(&ofn);
			if (!rc) {
				break;
			}

			CWaitCursor waitCursor;

			// f[^x[XobNAbv
			std::list<std::string> fileList;
			bool bSuccess = BackupBsfilterResource(filepath, fileList);

			waitCursor.Restore();

			if (!bSuccess) {
				DeleteFile(filepath);
				std::string message = CResourceManager::FormatResourceString(IDS_MSG_FAILED_TO_BACKUP_BSFILTER_DATABASE);
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONERROR);
			} else {
				std::string backupTitle = CResourceManager::FormatResourceString(IDS_MSG_BACKUP_THERE_FILES, m_param.dataFolder.c_str());

				std::string message = backupTitle;
				for (std::list<std::string>::iterator it = fileList.begin(); it != fileList.end(); ++it) {
					message += *it;
					message += "\r\n";
				}

				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
			}
		}
		break;
	}
}

//----------------------------------------------------------------------
// WM_NOTIFY nh
//----------------------------------------------------------------------

BOOL CBkBsfilSettingDialogProc::OnNotify(HWND hWnd, int idCtrl, NMHDR* pnmhdr)
{
	switch (pnmhdr->code) {
	case PSN_APPLY:
		{
			//
			// uOKv{^NbN̏
			//

			// spam Ɣ肳ꂽ[̏u
			if (IS_CHECKED(hWnd, IDC_RADIO_NO_MOVE)) {
				m_param.bkProfile.SetProcSpam(BkBsfilProfile::NoMove);
			}
			if (IS_CHECKED(hWnd, IDC_RADIO_GO_FOLDER)) {
				m_param.bkProfile.SetProcSpam(BkBsfilProfile::GoFolder);
			}
			if (IS_CHECKED(hWnd, IDC_RADIO_ADD_HEADER)) {
				m_param.bkProfile.SetProcSpam(BkBsfilProfile::AddHeader);
			}
			if (IS_CHECKED(hWnd, IDC_RADIO_GO_TRASH)) {
				m_param.bkProfile.SetProcSpam(BkBsfilProfile::GoTrash);
			}

			// NOTE: tH_͑IɎ擾ς݂Ȃ̂ŁAł͎擾Ȃ
			//       ܂AɎ擾ƂĂ\Ȃ̂ŎgȂB

			// tH_ֈړꍇɊe[{bNX̓ʒũtH_Ɉړ
			m_param.bkProfile.SetGoFolderSameRelativeFolderPath(IS_CHECKED(hWnd, IDC_CHECK_SAME_RELATIVE_FOLDER_PATH));

			// uwb_tv̏ꍇ̃wb_
			// NOTE: BkBsfilProfile Ńwb_񂪍ő咷ȓƂȂ悤A؂̂ĂĂB
			//       ̓`FbNŌ̕񂪕KvȂ̂ŁAł BkBsfilProfile ɐݒ肵ȂB
			std::string spamHeaderFieldName;
			std::string spamHeaderFieldBody;
			{
				GET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_NAME, &spamHeaderFieldName);
				spamHeaderFieldName = Util::Trim(spamHeaderFieldName);
				// trim ̒lĐݒ
				SET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_NAME, spamHeaderFieldName.c_str());


				GET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_BODY, &spamHeaderFieldBody);
				spamHeaderFieldBody = Util::Trim(spamHeaderFieldBody);
				// trim ̒lĐݒ
				SET_WINDOW_TEXT(hWnd, IDC_EDIT_SPAM_HEADER_FIELD_BODY,spamHeaderFieldBody.c_str());
			}

			// spam Ɣ肳ꂽ[͊ǂɂ
			m_param.bkProfile.SetSetReadToSpamMail(IS_CHECKED(hWnd, IDC_CHECK_SET_READ_TO_SPAM_MAIL));

			// N bsfilter f[^x[XQƂȂ
			m_param.bkProfile.SetDontCheckDbOnStart(IS_CHECKED(hWnd, IDC_CHECK_DONT_CHECK_DB_ON_START));

			// OɃbZ[W{bNX\Ȃ
			m_param.bkProfile.SetDisableBeforeMsgbox(IS_CHECKED(hWnd, IDC_CHECK_DISABLE_BEFORE_MSGBOX));

			// ʕ\̃bZ[W{bNX\Ȃ
			m_param.bkProfile.SetDisableResultMsgbox(IS_CHECKED(hWnd, IDC_CHECK_DISABLE_RESULT_MSGBOX));

			// MɑMzCgXgɒǉ
			m_param.bkProfile.SetAddToAddrToWhiteListOnSend(IS_CHECKED(hWnd, IDC_CHECK_ADD_TO_ADDR_TO_WHITELIST_ONSEND));

			// 莞у[wK clean ȃ[ spam wb_Ȃ
			m_param.bkProfile.SetDontRemoveSpamHeader(IS_CHECKED(hWnd, IDC_CHECK_DONT_REMOVE_SPAM_HEADER));

			// 莞у[wK spam ȃ[zCgXg珜
			m_param.bkProfile.SetRemoveSpamFromWhiteList(IS_CHECKED(hWnd, IDC_CHECK_REMOVE_SPAM_FROM_WHITELIST));


			//
			// ͂̃`FbNs
			//
			bool bValidate = true;

			do {
				std::string message;

				if (m_param.bkProfile.GetProcSpam() == BkBsfilProfile::GoFolder) {
					if (m_param.bkProfile.GetSpamFolder().length() == 0) {
						message = CResourceManager::FormatResourceString(IDS_MSG_SPECIFY_FOLDER_OF_SPAM_EMAIL);
						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}
				}

				if (m_param.bkProfile.GetProcSpam() == BkBsfilProfile::AddHeader) {
					if (spamHeaderFieldName.length() == 0) {
						message = CResourceManager::FormatResourceString(IDS_MSG_SPECIFY_HEADER_ADD_TO_EMAIL);
						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}
					if (!Util::IsAlnumString(spamHeaderFieldName.c_str())) {
						message = CResourceManager::FormatResourceString(IDS_MSG_SPECIFY_HEADER_ONLY_ALPHANUMERIC_CHARS);
						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}
					if (BkBsfilProfile::NUM_CHAR_SPAM_HEADER_FIELD_NAME_MAX < spamHeaderFieldName.length()) {
						message = CResourceManager::FormatResourceString(IDS_MSG_SPECIFY_IN_HEADER_TO_X_CHAR,
								BkBsfilProfile::NUM_CHAR_SPAM_HEADER_FIELD_NAME_MAX
							);

						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}

					if (spamHeaderFieldBody.length() == 0) {
						message = CResourceManager::FormatResourceString(IDS_MSG_SPECIFY_HEADER_STR_ADD_TO_EMAIL);
						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}
					if (!Util::IsAlnumString(spamHeaderFieldBody.c_str())) {
						message = CResourceManager::FormatResourceString(IDS_MSG_SPECIFY_HEADER_STR_ONLY_ALPHANUMERIC_CHARS);
						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}
					if (BkBsfilProfile::NUM_CHAR_SPAM_HEADER_FIELD_BODY_MAX < spamHeaderFieldBody.length()) {
						message = CResourceManager::FormatResourceString(IDS_MSG_SPECIFY_IN_HEADER_STR_TO_X_CHAR,
								BkBsfilProfile::NUM_CHAR_SPAM_HEADER_FIELD_BODY_MAX
							);

						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}
				}

			} while (false);

			// uwb_tv̏ꍇ̃wb_̓`FbNɐݒ肷
			m_param.bkProfile.SetSpamHeaderFieldName(spamHeaderFieldName);
			m_param.bkProfile.SetSpamHeaderFieldBody(spamHeaderFieldBody);

			if (!bValidate) {
				// vpeBV[gȂ
				SetWindowLong(hWnd, DWL_MSGRESULT, PSNRET_INVALID);	// PSNRET_INVALID: ̃y[WANeBuɂȂ
				return TRUE;
			}
		}
		return TRUE;
	}

	return FALSE;
}

//----------------------------------------------------------------------
// bsfilter f[^x[XobNAbv
//----------------------------------------------------------------------

bool CBkBsfilSettingDialogProc::BackupBsfilterResource(char* backupFilepath, std::list<std::string>& fileList)
{
	bool result = true;
	HZIP hzip = 0;

	do {

		ZRESULT zr;

		hzip = CreateZip(backupFilepath, 0);
		if (!hzip) {
			result = false;
			break;
		}


		CSLock cslock(m_param.pcsDatabase);

		// bsfilter ̐ݒt@C
		zr = ZipAdd(hzip, BSFILTER_CONFIG_FILENAME, m_param.bsfilterConfig.c_str());
		if (zr != 0) {
			result = false;
			break;
		} else {
			fileList.push_back(BSFILTER_CONFIG_FILENAME);
		}

		// bsfilter ̃f[^x[Xt@C
		char searchPath[MAX_PATH * 4];
		_snprintf(searchPath, sizeof(searchPath), "%s\\*.*", m_param.dbFolder.c_str());
		FORCE_ASCIZ(searchPath);

		HANDLE hFind = INVALID_HANDLE_VALUE;
		WIN32_FIND_DATA findData = { 0 };

		do {

			hFind = FindFirstFile(searchPath, &findData);
			if (hFind == INVALID_HANDLE_VALUE) {
				break;
			}

			for (;;) {

				if (strcmp(findData.cFileName, ".") != 0 && strcmp(findData.cFileName, "..") != 0
				 && !(findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {

					char dbFilepath[MAX_PATH * 4];
					_snprintf(dbFilepath, sizeof(dbFilepath), "%s\\%s", m_param.dbFolder.c_str(), findData.cFileName);
					FORCE_ASCIZ(dbFilepath);

					char zipFilepath[MAX_PATH * 4];
					_snprintf(zipFilepath, sizeof(zipFilepath), BSFILTER_DB_FOLDERNAME "\\%s", findData.cFileName);
					FORCE_ASCIZ(zipFilepath);

					zr = ZipAdd(hzip, zipFilepath, dbFilepath);
					if (zr != 0) {
						result = false;
						break;
					} else {
						fileList.push_back(zipFilepath);
					}
				}

				BOOL rc = FindNextFile(hFind, &findData);
				if (!rc) {
					break;
				}
			}

		} while (false);

		if (hFind != INVALID_HANDLE_VALUE) {
			FindClose(hFind);
		}

	} while (false);

	if (hzip) {
		CloseZip(hzip);
	}

	return result;
}

//----------------------------------------------------------------------
// bsfilter f[^x[XXgA
//----------------------------------------------------------------------

bool CBkBsfilSettingDialogProc::RestoreBsfilterResource(const char* backupFilepath, std::list<std::string>& fileList)
{
	bool result = true;
	HZIP hzip = 0;

	do {

		ZRESULT zr;

		hzip = OpenZip(backupFilepath, 0);
		if (!hzip) {
			result = false;
			break;
		}

		CSLock cslock(m_param.pcsDatabase);
		char extractPath[MAX_PATH * 4];

		_snprintf(extractPath, sizeof(extractPath), "%s\\", m_param.dataFolder.c_str());
		FORCE_ASCIZ(extractPath);

		zr = SetUnzipBaseDir(hzip, extractPath);
		if (zr != 0) {
			result = false;
			break;
		}

		ZIPENTRY ze = { 0 };
		zr = GetZipItem(hzip, -1, &ze);
		if (zr != 0) {
			result = false;
			break;
		}

		int numitems = ze.index;
		for (int zi = 0; zi < numitems; ++zi) {
			zr = GetZipItem(hzip, zi, &ze);
			if (zr != 0) {
				result = false;
				break;
			}

			// 0 oCg̃t@C(*.lock)WJꍇ ZR_FLATE Ŗ߂Ă͖̂ĂB
			zr = UnzipItem(hzip, zi, ze.name);
			if (zr != 0 && zr != ZR_FLATE) {
				result = false;
				break;
			} else {
				fileList.push_back(ze.name);
			}
		}

	} while (false);

	if (hzip) {
		CloseZip(hzip);
	}

	return result;
}

////////////////////////////////////////////////////////////////////////
// ̑̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

COtherSettingDialogProc::COtherSettingDialogProc(SettingDialogParam& param) :
	m_param(param)
{
	m_dlgCaption[0] = '\0';
}

//----------------------------------------------------------------------
// ̑̐ݒs_CAOvV[W
//----------------------------------------------------------------------
BOOL COtherSettingDialogProc::DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_MSG(hWnd, WM_INITDIALOG, OnInitDialog);
	HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
	HANDLE_MSG(hWnd, WM_NOTIFY, OnNotify);
	}

	return FALSE;
}

//----------------------------------------------------------------------
// WM_INITDIALOG nh
//----------------------------------------------------------------------

BOOL COtherSettingDialogProc::OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	//
	// s
	//

	// _CAÕ^Cg擾Ă
	GetWindowText(hWnd, m_dlgCaption, sizeof(m_dlgCaption));

	//
	// ReLXgj[̈ʒu
	//

	// ReLXgj[̈ʒu
	switch (m_param.ctxMenuProfile.GetMenuPosition()) {
	case ContextMenuProfile::ContextMenuTop:
		SET_CHECK(hWnd, IDC_RADIO_MENU_TOP, TRUE);
		break;
	case ContextMenuProfile::ContextMenuBottom:
	default:
		SET_CHECK(hWnd, IDC_RADIO_MENU_BOTTOM, TRUE);
		break;
	case ContextMenuProfile::ContextMenuPos:
		SET_CHECK(hWnd, IDC_RADIO_MENU_POS, TRUE);
		break;
	}

	// wʒu
	{
		char menuPos[1024];
		_snprintf(menuPos, sizeof(menuPos), "%d", m_param.ctxMenuProfile.GetMenuPos());
		FORCE_ASCIZ(menuPos);
		SET_WINDOW_TEXT(hWnd, IDC_EDIT_MENU_POS, menuPos);
	}
	ENABLE_WINDOW(hWnd, IDC_EDIT_MENU_POS, m_param.ctxMenuProfile.GetMenuPosition() == ContextMenuProfile::ContextMenuPos);
	ENABLE_WINDOW(hWnd, IDC_SPIN_MENU_POS, m_param.ctxMenuProfile.GetMenuPosition() == ContextMenuProfile::ContextMenuPos);

	// u㑤ɃZp[^[v
	SET_CHECK(hWnd, IDC_CHECK_MENU_POS_UPPER_SEPARATOR, m_param.ctxMenuProfile.GetUpperSeparator());

	// uɃZp[^[v
	SET_CHECK(hWnd, IDC_CHECK_MENU_POS_LOWER_SEPARATOR, m_param.ctxMenuProfile.GetLowerSeparator());

	//
	// bsfilter XNvgł̎ŝ߂̐ݒ
	//

	// bsfilter XNvg𗘗p
	SET_CHECK(hWnd, IDC_CHECK_USE_BSFILTER_SCRIPT, m_param.execBsScriptProfile.GetUseBsfilterScript());

	// ruby.exe ̃tpX
	ENABLE_WINDOW(hWnd, IDC_RUBY_MODULE_PATH, m_param.execBsScriptProfile.GetUseBsfilterScript());
	ENABLE_WINDOW(hWnd, IDC_BUTTON_SEL_RUBY_MODULE, m_param.execBsScriptProfile.GetUseBsfilterScript());
	SET_WINDOW_TEXT(hWnd, IDC_RUBY_MODULE_PATH, m_param.execBsScriptProfile.GetRubyModulePath().c_str());

	return TRUE;
}

//----------------------------------------------------------------------
// WM_COMMAND nh
//----------------------------------------------------------------------

void COtherSettingDialogProc::OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify)
{
	switch (idCtl) {
	//
	// ReLXgj[̈ʒu
	//
	case IDC_RADIO_MENU_TOP:
	case IDC_RADIO_MENU_BOTTOM:
	case IDC_RADIO_MENU_POS:
		{
			BOOL bMenuPos = IS_CHECKED(hWnd, IDC_RADIO_MENU_POS);

			ENABLE_WINDOW(hWnd, IDC_EDIT_MENU_POS, bMenuPos);
			ENABLE_WINDOW(hWnd, IDC_SPIN_MENU_POS, bMenuPos);
		}
		break;

	//
	// bsfilter XNvgł̎ŝ߂̐ݒ
	//
	case IDC_CHECK_USE_BSFILTER_SCRIPT:
		{
			BOOL bUseBsfilterScript = IS_CHECKED(hWnd, IDC_CHECK_USE_BSFILTER_SCRIPT);

			ENABLE_WINDOW(hWnd, IDC_RUBY_MODULE_PATH, bUseBsfilterScript);
			ENABLE_WINDOW(hWnd, IDC_BUTTON_SEL_RUBY_MODULE, bUseBsfilterScript);
		}
		break;

	case IDC_BUTTON_SEL_RUBY_MODULE:	// ruby.exe ̃tpXI
		{
			// t@C𓾂
			char filepath[MAX_PATH * 4];

			_snprintf(filepath, sizeof(filepath), "ruby.exe");
			FORCE_ASCIZ(filepath);
			std::string strFilter = CResourceManager::FormatResourceString(IDS_EXEC_BSFS_OF_RUBY_MODULE_FILTER);
			MAKE_OPENFILENAME_FILTER(&strFilter);
			std::string strTitle = CResourceManager::FormatResourceString(IDS_EXEC_BSFS_OF_RUBY_MODULE_TITLE);
			std::string strDefExt = CResourceManager::FormatResourceString(IDS_EXEC_BSFS_OF_RUBY_MODULE_DEF_EXT);

			OPENFILENAME ofn;
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hWnd;
			ofn.lpstrFilter = strFilter.c_str();
			ofn.nFilterIndex = 1;
			ofn.lpstrFile = filepath;
			ofn.nMaxFile = sizeof(filepath);
			ofn.lpstrTitle = strTitle.c_str();
			ofn.Flags = OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
			ofn.lpstrDefExt = strDefExt.c_str();

			BOOL rc = GetOpenFileName(&ofn);
			if (!rc) {
				break;
			}

			SET_WINDOW_TEXT(hWnd, IDC_RUBY_MODULE_PATH, filepath);
		}
		break;
	}
}

//----------------------------------------------------------------------
// WM_NOTIFY nh
//----------------------------------------------------------------------

BOOL COtherSettingDialogProc::OnNotify(HWND hWnd, int idCtl, NMHDR* pnmhdr)
{
	switch (pnmhdr->code) {
	case PSN_APPLY:
		{
			//
			// uOKv{^NbN̏
			//

			//
			// ReLXgj[̈ʒu
			//

			// ReLXgj[̈ʒu
			if (IS_CHECKED(hWnd, IDC_RADIO_MENU_TOP)) {
				m_param.ctxMenuProfile.SetMenuPosition(ContextMenuProfile::ContextMenuTop);
			}
			if (IS_CHECKED(hWnd, IDC_RADIO_MENU_BOTTOM)) {
				m_param.ctxMenuProfile.SetMenuPosition(ContextMenuProfile::ContextMenuBottom);
			}
			if (IS_CHECKED(hWnd, IDC_RADIO_MENU_POS)) {
				m_param.ctxMenuProfile.SetMenuPosition(ContextMenuProfile::ContextMenuPos);
			}

			// wʒu
			std::string menuPos;
			{
				GET_WINDOW_TEXT(hWnd, IDC_EDIT_MENU_POS, &menuPos);
				menuPos = Util::Trim(menuPos);
				if (menuPos.length() == 0) {
					menuPos = "0";
				}

				// lĐݒ
				SET_WINDOW_TEXT(hWnd, IDC_EDIT_MENU_POS, menuPos.c_str());
				m_param.ctxMenuProfile.SetMenuPos(atoi(menuPos.c_str()));
			}

			// u㑤ɃZp[^[v
			m_param.ctxMenuProfile.SetUpperSeparator(IS_CHECKED(hWnd, IDC_CHECK_MENU_POS_UPPER_SEPARATOR));

			// uɃZp[^[v
			m_param.ctxMenuProfile.SetLowerSeparator(IS_CHECKED(hWnd, IDC_CHECK_MENU_POS_LOWER_SEPARATOR));

			//
			// bsfilter XNvgł̎ŝ߂̐ݒ
			//
			{
				m_param.execBsScriptProfile.SetUseBsfilterScript(IS_CHECKED(hWnd, IDC_CHECK_USE_BSFILTER_SCRIPT));
			}

			{
				std::string rubyModulePath;
				GET_WINDOW_TEXT(hWnd, IDC_RUBY_MODULE_PATH, &rubyModulePath);
				rubyModulePath = Util::Trim(rubyModulePath);
				// trim ̒lĐݒ
				SET_WINDOW_TEXT(hWnd, IDC_RUBY_MODULE_PATH, rubyModulePath.c_str());
				m_param.execBsScriptProfile.SetRubyModulePath(rubyModulePath);
			}

			bool bValidate = true;

			if (m_param.execBsScriptProfile.GetUseBsfilterScript()) {

				do {

					std::string message;
					struct _stat fsts;

					if (m_param.execBsScriptProfile.GetRubyModulePath().length() == 0) {
						message = CResourceManager::FormatResourceString(IDS_MSG_SPECIFY_RUBY_MODULE_PATH);
						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}

					if (_stat(m_param.execBsScriptProfile.GetRubyModulePath().c_str(), &fsts) == 0 && fsts.st_mode & _S_IFREG
					 && Util::EndsWith(m_param.execBsScriptProfile.GetRubyModulePath(), "\\ruby.exe")) {
						// OK
					} else {
						message = CResourceManager::FormatResourceString(IDS_MSG_INVALID_RUBY_MODULE_PATH);
						MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
						bValidate = false;
						break;
					}

				} while (false);
			}

			if (!bValidate) {
				// vpeBV[gȂ
				SetWindowLong(hWnd, DWL_MSGRESULT, PSNRET_INVALID);	// PSNRET_INVALID: ̃y[WANeBuɂȂ
				return TRUE;
			}

		}
		return TRUE;
	}

	return FALSE;
}

////////////////////////////////////////////////////////////////////////
// zCgXg̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

#define ENABLE_WHITE_LIST_EDIT_BUTTONS(hWnd_) do { \
	HWND listCtrl_ = GetDlgItem((hWnd_), IDC_WHITE_MAIL_LIST); \
	int index_ = ListView_GetNextItem((listCtrl_), -1, LVNI_SELECTED); \
	if (0 <= index_) { \
		ENABLE_WINDOW((hWnd_), IDC_ADD_MAIL, TRUE); \
		ENABLE_WINDOW((hWnd_), IDC_UPDATE_MAIL, TRUE); \
		ENABLE_WINDOW((hWnd_), IDC_DEL_MAIL, TRUE); \
	} else { \
		ENABLE_WINDOW((hWnd_), IDC_ADD_MAIL, TRUE); \
		ENABLE_WINDOW((hWnd_), IDC_UPDATE_MAIL, TRUE); \
		ENABLE_WINDOW((hWnd_), IDC_DEL_MAIL, FALSE); \
	} \
} while (false)

// [AhXꗗ̍ڂ̃CfbNX
#define INDEX_COLUMN_MAIL_ADDRESS_TYPE	0		// AhX̎
#define INDEX_COLUMN_MAIL_ADDRESS	1		// AhX
#define INDEX_COLUMN_MAIL_NOTE		2		// l

// AhXꗗpC[WXg̃CfbNX
#define INDEX_IMAGE_ICON_EMAIL	0		// [AhX
#define INDEX_IMAGE_ICON_DOMAIN	1		// hC

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CWhiteListDialogProc::CWhiteListDialogProc(SettingDialogParam& param) :
	m_param(param)
{
	m_dlgCaption[0] = '\0';

	// AhXꗗpC[WXg
	m_hImgList = ImageList_Create(18, 16, ILC_COLOR24 | ILC_MASK, 2, 1);
	HICON hImage;
	hImage = CResourceManager::LoadIconImage(MAKEINTRESOURCE(IDI_ICON_EMAIL), 18, 16, LR_DEFAULTCOLOR);
	ImageList_AddIcon(m_hImgList, hImage);
	hImage = CResourceManager::LoadIconImage(MAKEINTRESOURCE(IDI_ICON_DOMAIN), 18, 16, LR_DEFAULTCOLOR);
	ImageList_AddIcon(m_hImgList, hImage);

	// \[g̖̃rbg}bv
	m_bmUpArrow = CResourceManager::LoadBitmapImage(MAKEINTRESOURCE(IDB_UP_ARROW), 14, 14, LR_LOADMAP3DCOLORS);
	m_bmDownArrow = CResourceManager::LoadBitmapImage(MAKEINTRESOURCE(IDB_DOWN_ARROW), 14, 14, LR_LOADMAP3DCOLORS);
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

CWhiteListDialogProc::~CWhiteListDialogProc()
{
	if (m_hImgList) {
		ImageList_Destroy(m_hImgList);
	}
}

//----------------------------------------------------------------------
// zCgXg̐ݒs_CAOvV[W
//----------------------------------------------------------------------

BOOL CWhiteListDialogProc::DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_MSG(hWnd, WM_INITDIALOG, OnInitDialog);
	HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
	HANDLE_MSG(hWnd, WM_NOTIFY, OnNotify);
	}

	return FALSE;
}

//----------------------------------------------------------------------
// WM_INITDIALOG nh
//----------------------------------------------------------------------

BOOL CWhiteListDialogProc::OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	//
	// s
	//

	// _CAÕ^Cg擾Ă
	GetWindowText(hWnd, m_dlgCaption, sizeof(m_dlgCaption));

	//
	// [AhXꗗ
	//
	std::string columnTitleAddressType = CResourceManager::FormatResourceString(IDS_WHITELIST_COLUMN_EMAIL_ADDRESS_TYPE);
	std::string columnTitleMailAddress = CResourceManager::FormatResourceString(IDS_WHITELIST_COLUMN_EMAIL_ADDRESS);
	std::string columnTitleNote = CResourceManager::FormatResourceString(IDS_WHITELIST_COLUMN_EMAIL_NOTE);

	HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);

	// sŜIł悤ɂ
	DWORD extendedStyle = ListView_GetExtendedListViewStyle(listCtrl);
	ListView_SetExtendedListViewStyle(listCtrl, extendedStyle |= LVS_EX_FULLROWSELECT);

	// AhXꗗpC[WXgݒ肷
	ListView_SetImageList(listCtrl, m_hImgList, LVSIL_SMALL);

	LV_COLUMN lvColumn;

	// AhX̎
	ZeroMemory(&lvColumn, sizeof(lvColumn));
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = m_param.bkWhiteListProfileEnv.GetAddrTypeItemWidth();
	lvColumn.pszText = (char*) columnTitleAddressType.c_str();
	ListView_InsertColumn(listCtrl, INDEX_COLUMN_MAIL_ADDRESS_TYPE, &lvColumn);

	// AhX
	ZeroMemory(&lvColumn, sizeof(lvColumn));
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = m_param.bkWhiteListProfileEnv.GetEmailAddrItemWidth();
	lvColumn.pszText = (char*) columnTitleMailAddress.c_str();
	ListView_InsertColumn(listCtrl, INDEX_COLUMN_MAIL_ADDRESS, &lvColumn);

	// l
	ZeroMemory(&lvColumn, sizeof(lvColumn));
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = m_param.bkWhiteListProfileEnv.GetNoteItemWidth();
	lvColumn.pszText = (char*) columnTitleNote.c_str();
	ListView_InsertColumn(listCtrl, INDEX_COLUMN_MAIL_NOTE, &lvColumn);

	// [AhXꗗ̃^Cgɖݒ肷
	SetAddrListSortArrow(listCtrl);

	// ꗗɃAhX̐ݒ肷
	ListView_SetItemCount(listCtrl, m_param.whiteList.Count());



	//
	// [
	//

	// NOTE: ł邱ƂɒӁB
	//       Ƃ肠擾̍ۂ͔{ȏ̃obt@݂邱ƁB
	// [AhX(ő啶ݒ肷)
	SendMessage(GetDlgItem(hWnd, IDC_MAIL_ADDRESS), EM_SETLIMITTEXT, NUM_CHAR_MAIL_ADDRESS_MAX, 0);
	// l(ő啶ݒ肷)
	SendMessage(GetDlgItem(hWnd, IDC_MAIL_NOTE), EM_SETLIMITTEXT, NUM_CHAR_MAIL_NOTE_MAX, 0);


	//
	// ҏW{^
	//
	ENABLE_WHITE_LIST_EDIT_BUTTONS(hWnd);

	ENABLE_WINDOW(hWnd, IDC_MAIL_IMPORT, TRUE);
	ENABLE_WINDOW(hWnd, IDC_MAIL_EXPORT, TRUE);

	return TRUE;
}

//----------------------------------------------------------------------
// WM_COMMAND nh
//----------------------------------------------------------------------

void CWhiteListDialogProc::OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify)
{
	switch (idCtl) {
	case IDC_ADD_MAIL:	// ǉ
		{
			std::string message;

			char email[NUM_CHAR_MAIL_ADDRESS_MAX * 3] = "";
			char note[NUM_CHAR_MAIL_NOTE_MAX * 3] = "";

			// [AhXAl擾
			Edit_GetText(GetDlgItem(hWnd, IDC_MAIL_ADDRESS), email, sizeof(email));
			Edit_GetText(GetDlgItem(hWnd, IDC_MAIL_NOTE), note, sizeof(note));

			std::string semail = Util::Trim(email, " \t@");
			std::string snote = Util::Trim(note);

			// ͂Ă邩`FbN
			if (semail.length() == 0) {
				message = CResourceManager::FormatResourceString(IDS_MSG_ENTER_EMAIL_ADDRESS);
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
				SetFocus(GetDlgItem(hWnd, IDC_MAIL_ADDRESS));
				break;
			}

			if (m_param.whiteList.IsExist(semail.c_str())) {
				message = CResourceManager::FormatResourceString(IDS_MSG_EMAIL_ADDRESS_ALREADY_REGISTERED_OR_UPDATE);
				int rc = MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_YESNO | MB_ICONINFORMATION);
				if (rc != IDYES) {
					SetFocus(GetDlgItem(hWnd, IDC_MAIL_ADDRESS));
					break;
				}

				// XV
				UpdateMail(hWnd, semail.c_str(), snote.c_str());
				break;
			}

			// o^
			AddMail(hWnd, semail.c_str(), snote.c_str());
		}
		break;

	case IDC_UPDATE_MAIL:	// XV
		{
			std::string message;

			char email[NUM_CHAR_MAIL_ADDRESS_MAX * 3] = "";
			char note[NUM_CHAR_MAIL_NOTE_MAX * 3] = "";

			// [AhXAl擾
			Edit_GetText(GetDlgItem(hWnd, IDC_MAIL_ADDRESS), email, sizeof(email));
			Edit_GetText(GetDlgItem(hWnd, IDC_MAIL_NOTE), note, sizeof(note));

			std::string semail = Util::Trim(email, " \t@");
			std::string snote = Util::Trim(note);

			// ͂Ă邩`FbN
			if (semail.length() == 0) {
				message = CResourceManager::FormatResourceString(IDS_MSG_ENTER_EMAIL_ADDRESS);
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
				SetFocus(GetDlgItem(hWnd, IDC_MAIL_ADDRESS));
				break;
			}

			if (!m_param.whiteList.IsExist(semail.c_str())) {
				message = CResourceManager::FormatResourceString(IDS_MSG_EMAIL_ADDRESS_NOT_REGISTERED_OR_ADD);
				int rc = MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_YESNO | MB_ICONINFORMATION);
				if (rc != IDYES) {
					SetFocus(GetDlgItem(hWnd, IDC_MAIL_ADDRESS));
					break;
				}

				// ǉ
				AddMail(hWnd, semail.c_str(), snote.c_str());
				break;
			}

			// XV
			UpdateMail(hWnd, semail.c_str(), snote.c_str());
		}
		break;

	case IDC_DEL_MAIL:	// 폜
		{
			std::string message;

			HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);

			int index = ListView_GetNextItem(listCtrl, -1, LVNI_SELECTED);
			if (index < 0) {
				message = CResourceManager::FormatResourceString(IDS_MSG_CHOOSE_IN_THE_LIST_TO_DELETE_EMAIL_INFO);
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
				break;
			}

			DeleteMail(hWnd);
		}
		break;

	case IDC_MAIL_IMPORT:	// C|[g
		{
			std::string strFilter = CResourceManager::FormatResourceString(IDS_IMPORT_WHITELIST_FILE_FILTER);
			MAKE_OPENFILENAME_FILTER(&strFilter);
			std::string strTitle = CResourceManager::FormatResourceString(IDS_IMPORT_WHITELIST_TITLE);

			char filepath[MAX_PATH * 4] = "";

			OPENFILENAME ofn;
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hWnd;
			ofn.lpstrFilter = strFilter.c_str();
			ofn.nFilterIndex = 1;
			ofn.lpstrFile = filepath;
			ofn.nMaxFile = sizeof(filepath);
			ofn.lpstrTitle = strTitle.c_str();
			ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;

			BOOL rc = GetOpenFileName(&ofn);
			if (!rc) {
				break;
			}

			CWaitCursor waitCursor;

			m_param.whiteList.Import(filepath);
			m_param.whiteList.Sort();

			// ꗗɃAhX̐ݒ肷
			HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);
			ListView_SetItemCount(listCtrl, m_param.whiteList.Count());

			InvalidateRect(listCtrl, 0, TRUE);

			ENABLE_WHITE_LIST_EDIT_BUTTONS(hWnd);

			waitCursor.Restore();

			std::string message = CResourceManager::FormatResourceString(IDS_MSG_COMPLETE_IMPORT_WHITE_LIST);
			MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
		}
		break;

	case IDC_MAIL_EXPORT:	// GNX|[g
		{
			SYSTEMTIME systime = { 0 };
			GetLocalTime(&systime);

			char filepath[MAX_PATH * 4];
			_snprintf(filepath, sizeof(filepath), "WhiteList_%04d%02d%02d_%02d%02d%02d.txt",
				systime.wYear,
				systime.wMonth,
				systime.wDay,
				systime.wHour,
				systime.wMinute,
				systime.wSecond
			);
			FORCE_ASCIZ(filepath);

			std::string strFilter = CResourceManager::FormatResourceString(IDS_EXPORT_WHITELIST_FILE_FILTER);
			MAKE_OPENFILENAME_FILTER(&strFilter);
			std::string strTitle = CResourceManager::FormatResourceString(IDS_EXPORT_WHITELIST_TITLE);
			std::string strDefExt = CResourceManager::FormatResourceString(IDS_EXPORT_WHITELIST_FILE_DEF_EXT);

			OPENFILENAME ofn;
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hWnd;
			ofn.lpstrFilter = strFilter.c_str();
			ofn.nFilterIndex = 1;
			ofn.lpstrFile = filepath;
			ofn.nMaxFile = sizeof(filepath);
			ofn.lpstrTitle = strTitle.c_str();
			ofn.Flags = OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
			ofn.lpstrDefExt = strDefExt.c_str();

			BOOL rc = GetSaveFileName(&ofn);
			if (!rc) {
				break;
			}

			CWaitCursor waitCursor;

			m_param.whiteList.Export(filepath);

			waitCursor.Restore();

			std::string message = CResourceManager::FormatResourceString(IDS_MSG_COMPLETE_EXPORT_WHITE_LIST);
			MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
		}
		break;
	}
}

//----------------------------------------------------------------------
// WM_NOTIFY nh
//----------------------------------------------------------------------

BOOL CWhiteListDialogProc::OnNotify(HWND hWnd, int idCtrl, NMHDR* pnmhdr)
{
#define __FUNCNAME__ "CWhiteListDialogProc::OnNotify()"

	switch (pnmhdr->code) {
	case PSN_APPLY:
	case PSN_RESET:
		{
			//
			// uOKv{^܂́uLZv{^NbN̏
			//

			// ɐݒς݂Ȃ̂ŁuOKvɑ΂ĉȂB

			// ݒۑ
			m_param.bkWhiteListProfileEnv.SetSortKey(m_param.whiteList.GetSortKey());
			m_param.bkWhiteListProfileEnv.SetAscending(m_param.whiteList.IsAscending());

			HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);
			HWND listHdr = ListView_GetHeader(listCtrl);
			int itemCount = Header_GetItemCount(listHdr);
			for (int i = 0; i < itemCount; ++i) {

				HDITEM hdItem;
				ZeroMemory(&hdItem, sizeof(hdItem));

				// l擾
				hdItem.mask = HDI_WIDTH;
				Header_GetItem(listHdr, i, &hdItem);

				int width = hdItem.cxy;

				switch (i) {
				case INDEX_COLUMN_MAIL_ADDRESS_TYPE:
					m_param.bkWhiteListProfileEnv.SetAddrTypeItemWidth(width);
					break;
				case INDEX_COLUMN_MAIL_ADDRESS:
					m_param.bkWhiteListProfileEnv.SetEmailAddrItemWidth(width);
					break;
				case INDEX_COLUMN_MAIL_NOTE:
					m_param.bkWhiteListProfileEnv.SetNoteItemWidth(width);
					break;
				}
			}
		}

		return TRUE;
	}

	switch (pnmhdr->idFrom) {
	case IDC_WHITE_MAIL_LIST:	// [AhXꗗ

		switch (pnmhdr->code) {
		case LVN_GETDISPINFO:
			{
				LV_DISPINFO* pDispInfo = (LV_DISPINFO*) pnmhdr;

				MailAddressInfo& mai = m_param.whiteList.GetAt(pDispInfo->item.iItem);
				static std::string addrTypeEmail = CResourceManager::FormatResourceString(IDS_WHITELIST_ADDRESS_TYPE_EMAIL);
				static std::string addrTypeDomain = CResourceManager::FormatResourceString(IDS_WHITELIST_ADDRESS_TYPE_DOMAIN);

				switch (pDispInfo->item.iSubItem) {
				case INDEX_COLUMN_MAIL_ADDRESS_TYPE:
					if (pDispInfo->item.mask & LVIF_TEXT) {
						pDispInfo->item.pszText = " ";
						switch (mai.GetAddressType()) {
						case MailAddressInfo::AddressEmail:
							pDispInfo->item.pszText = (char*) addrTypeEmail.c_str();
							break;
						case MailAddressInfo::AddressDomain:
							pDispInfo->item.pszText = (char*) addrTypeDomain.c_str();
							break;
						}
					}
					if (pDispInfo->item.mask & LVIF_IMAGE) {
						switch (mai.GetAddressType()) {
						case MailAddressInfo::AddressEmail:
							pDispInfo->item.iImage = INDEX_IMAGE_ICON_EMAIL;
							break;
						case MailAddressInfo::AddressDomain:
							pDispInfo->item.iImage = INDEX_IMAGE_ICON_DOMAIN;
							break;
						}
					}
					break;

				case INDEX_COLUMN_MAIL_ADDRESS:
					if (pDispInfo->item.mask & LVIF_TEXT) {
						pDispInfo->item.pszText = (char*) mai.GetMailAddress().c_str();
					}
					break;

				case INDEX_COLUMN_MAIL_NOTE:
					if (pDispInfo->item.mask & LVIF_TEXT) {
						pDispInfo->item.pszText = (char*) mai.GetNote().c_str();
					}
					break;
				}
			}
			break;

		case LVN_COLUMNCLICK:
			{
				NMLISTVIEW* pnmlv = (NMLISTVIEW*) pnmhdr;

				HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);

				// ݑIĂ̂Ă
				std::string curaddr;

				int index = ListView_GetNextItem(listCtrl, -1, LVNI_SELECTED);
				if (0 <= index) {
					MailAddressInfo& mai = m_param.whiteList.GetAt(index);
					curaddr = mai.GetMailAddress();
				}


				WhiteList::SortKey sortKey = WhiteList::SortAddrType;
				switch (pnmlv->iSubItem) {
				case INDEX_COLUMN_MAIL_ADDRESS_TYPE:
					sortKey = WhiteList::SortAddrType;
					break;
				case INDEX_COLUMN_MAIL_ADDRESS:
					sortKey = WhiteList::SortEmailAddr;
					break;
				case INDEX_COLUMN_MAIL_NOTE:
					sortKey = WhiteList::SortNote;
					break;
				}

				if (m_param.whiteList.GetSortKey() != sortKey) {
					// X\[gĂ鍀ڂƁAႤڂIꂽꍇ́AƂB
					m_param.whiteList.SetAscending(true);
				} else {
					// ڂł΁AE~tɂB
					m_param.whiteList.SetAscending(!m_param.whiteList.IsAscending());
				}
				// \[gL[ݒ肷
				m_param.whiteList.SetSortKey(sortKey);
				// \[g
				m_param.whiteList.Sort();


				// [AhXꗗ̃^Cgɖݒ肷
				SetAddrListSortArrow(listCtrl);

				InvalidateRect(listCtrl, 0, TRUE);

				if (0 <= index) {
					index = m_param.whiteList.GetIndex(curaddr.c_str());
					SELECT_LISTVIEW(listCtrl, index);
				}
			}
			break;

		case LVN_KEYDOWN:
			{
				// DEL L[ƂɃ[AhXꗗőIĂ̂폜
				NMLVKEYDOWN* plvKeyDown = (NMLVKEYDOWN*) pnmhdr;
				if (plvKeyDown->wVKey == VK_DELETE) {
					DeleteMail(hWnd);
					return TRUE;
				}
			}
			break;

		case NM_DBLCLK:
			{
				// _uNbNƂɃ[Ɉꗗ̒lݒ肷
				HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);

				int index = ListView_GetNextItem(listCtrl, -1, LVNI_SELECTED);
				if (index < 0) {
					return TRUE;
				}

				MailAddressInfo& mai = m_param.whiteList.GetAt(index);

				Edit_SetText(GetDlgItem(hWnd, IDC_MAIL_ADDRESS), mai.GetMailAddress().c_str());
				Edit_SetText(GetDlgItem(hWnd, IDC_MAIL_NOTE), mai.GetNote().c_str());
			}
			return TRUE;

		case LVN_ITEMCHANGED:
			{
				ENABLE_WHITE_LIST_EDIT_BUTTONS(hWnd);
			}
			return TRUE;
		}
		break;
	}

	return FALSE;

#undef __FUNCNAME__
}

//----------------------------------------------------------------------
// [[AhXꗗɒǉ
//----------------------------------------------------------------------

void CWhiteListDialogProc::AddMail(HWND hWnd, const char* email, const char* note)
{
	HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);

	m_param.whiteList.Add(email, note);
	m_param.whiteList.Sort();
	ListView_SetItemCount(listCtrl, m_param.whiteList.Count());
	InvalidateRect(listCtrl, 0, TRUE);

	int index = m_param.whiteList.GetIndex(email);
	if (index < 0) {
		return;
	}

	SELECT_LISTVIEW(listCtrl, index);
}

//----------------------------------------------------------------------
// [AhXꗗ̃[XV
//----------------------------------------------------------------------

void CWhiteListDialogProc::UpdateMail(HWND hWnd, const char* email, const char* note)
{
	HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);

	m_param.whiteList.Update(email, note);
	m_param.whiteList.Sort();
	ListView_SetItemCount(listCtrl, m_param.whiteList.Count());
	InvalidateRect(listCtrl, 0, TRUE);

	int index = m_param.whiteList.GetIndex(email);
	if (index < 0) {
		return;
	}

	SELECT_LISTVIEW(listCtrl, index);
}

//----------------------------------------------------------------------
// [AhXꗗ烁[폜
//----------------------------------------------------------------------

void CWhiteListDialogProc::DeleteMail(HWND hWnd)
{
	HWND listCtrl = GetDlgItem(hWnd, IDC_WHITE_MAIL_LIST);

	int index = ListView_GetNextItem(listCtrl, -1, LVNI_SELECTED);
	if (index < 0) {
		return;
	}

	bool bDelete = m_param.whiteList.DeleteAt(index);
	if (!bDelete) {
		return;
	}

	m_param.whiteList.Sort();
	ListView_SetItemCount(listCtrl, m_param.whiteList.Count());
	InvalidateRect(listCtrl, 0, TRUE);

	// 폜s̉̂̂I
	int count = m_param.whiteList.Count();
	if (index < count) {
		SELECT_LISTVIEW(listCtrl, index);
	} else {
		int nextIndex = index - 1;
		if (0 <= nextIndex && nextIndex < count) {
			SELECT_LISTVIEW(listCtrl, nextIndex);
		}
	}

	ENABLE_WHITE_LIST_EDIT_BUTTONS(hWnd);
}

//----------------------------------------------------------------------
// [AhXꗗ̃^Cgɖݒ肷
//----------------------------------------------------------------------

void CWhiteListDialogProc::SetAddrListSortArrow(HWND listCtrl)
{
	// ڂ̃CfbNX𓾂
	int columnIndex = INDEX_COLUMN_MAIL_ADDRESS_TYPE;
	switch (m_param.whiteList.GetSortKey()) {
	case WhiteList::SortAddrType:
		columnIndex = INDEX_COLUMN_MAIL_ADDRESS_TYPE;
		break;
	case WhiteList::SortEmailAddr:
		columnIndex = INDEX_COLUMN_MAIL_ADDRESS;
		break;
	case WhiteList::SortNote:
		columnIndex = INDEX_COLUMN_MAIL_NOTE;
		break;
	}

	// ǂ𓾂
	bool bAscending = m_param.whiteList.IsAscending();

	SetSortArrow(listCtrl, columnIndex, bAscending, m_bmUpArrow, m_bmDownArrow);
}

////////////////////////////////////////////////////////////////////////
// CHK [h̐ݒs_CAOvV[W̋@\(OK/NG ̃x[X)
////////////////////////////////////////////////////////////////////////

#define ENABLE_CHK_WORD_LIST_EDIT_BUTTONS(hWnd_) do { \
	HWND listCtrl_ = GetDlgItem((hWnd_), GetChkWordListCtrlId()); \
	int index_ = ListView_GetNextItem((listCtrl_), -1, LVNI_SELECTED); \
	if (0 <= index_) { \
		ENABLE_WINDOW((hWnd_), GetAddChkWordCtrlId(), TRUE); \
		ENABLE_WINDOW((hWnd_), GetUpdateChkWordCtrlId(), TRUE); \
		ENABLE_WINDOW((hWnd_), GetDelChkWordCtrlId(), TRUE); \
	} else { \
		ENABLE_WINDOW((hWnd_), GetAddChkWordCtrlId(), TRUE); \
		ENABLE_WINDOW((hWnd_), GetUpdateChkWordCtrlId(), TRUE); \
		ENABLE_WINDOW((hWnd_), GetDelChkWordCtrlId(), FALSE); \
	} \
} while (false)

// CHK [hꗗ̍ڂ̃CfbNX
#define INDEX_COLUMN_CHK_WORD_TYPE	0		// 
#define INDEX_COLUMN_CHK_WORD	1		// CHK [h
#define INDEX_COLUMN_CHK_IS_REGEX	2		// K\
#define INDEX_COLUMN_CHK_IS_CASE	3		// 召

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CChkWordListDialogProc::CChkWordListDialogProc(SettingDialogParam& param) :
	m_param(param)
{
	m_dlgCaption[0] = '\0';

	// \[g̖̃rbg}bv
	m_bmUpArrow = CResourceManager::LoadBitmapImage(MAKEINTRESOURCE(IDB_UP_ARROW), 14, 14, LR_LOADMAP3DCOLORS);
	m_bmDownArrow = CResourceManager::LoadBitmapImage(MAKEINTRESOURCE(IDB_DOWN_ARROW), 14, 14, LR_LOADMAP3DCOLORS);
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

CChkWordListDialogProc::~CChkWordListDialogProc()
{
}

//----------------------------------------------------------------------
// CHK [h̐ݒs_CAOvV[W
//----------------------------------------------------------------------

BOOL CChkWordListDialogProc::DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_MSG(hWnd, WM_INITDIALOG, OnInitDialog);
	HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
	HANDLE_MSG(hWnd, WM_NOTIFY, OnNotify);
	}

	return FALSE;
}

//----------------------------------------------------------------------
// WM_INITDIALOG nh
//----------------------------------------------------------------------

BOOL CChkWordListDialogProc::OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	//
	// s
	//

	// _CAÕ^Cg擾Ă
	GetWindowText(hWnd, m_dlgCaption, sizeof(m_dlgCaption));

	//
	// CHK [hgp
	//
	SET_CHECK(hWnd, GetUseChkWordCtrlId(), GetChkWordProfile().IsUseChkWord());

	//
	// CHK [hꗗ
	//
	std::string columnTitleWordType = CResourceManager::FormatResourceString(GetChkWordListWordTypeTitleResId());
	std::string columnTitleChkWord = CResourceManager::FormatResourceString(GetChkWordListChkWordTitleResId());
	std::string columnTitleRegex = CResourceManager::FormatResourceString(GetChkWordListIsRegexTitleResId());
	std::string columnTitleCase = CResourceManager::FormatResourceString(GetChkWordListIsCaseTitleResId());

	HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());

	// sŜIł悤ɂ
	DWORD extendedStyle = ListView_GetExtendedListViewStyle(listCtrl);
	ListView_SetExtendedListViewStyle(listCtrl, extendedStyle |= LVS_EX_FULLROWSELECT);

	LV_COLUMN lvColumn;

	// 
	ZeroMemory(&lvColumn, sizeof(lvColumn));
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = GetChkWordProfileEnv().GetWordTypeItemWidth();
	lvColumn.pszText = (char*) columnTitleWordType.c_str();
	ListView_InsertColumn(listCtrl, INDEX_COLUMN_CHK_WORD_TYPE, &lvColumn);

	// CHK [h
	ZeroMemory(&lvColumn, sizeof(lvColumn));
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = GetChkWordProfileEnv().GetChkWordItemWidth();
	lvColumn.pszText = (char*) columnTitleChkWord.c_str();
	ListView_InsertColumn(listCtrl, INDEX_COLUMN_CHK_WORD, &lvColumn);

	// K\
	ZeroMemory(&lvColumn, sizeof(lvColumn));
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = GetChkWordProfileEnv().GetRegexItemWidth();
	lvColumn.pszText = (char*) columnTitleRegex.c_str();
	ListView_InsertColumn(listCtrl, INDEX_COLUMN_CHK_IS_REGEX, &lvColumn);

	// 召
	ZeroMemory(&lvColumn, sizeof(lvColumn));
	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvColumn.fmt = LVCFMT_LEFT;
	lvColumn.cx = GetChkWordProfileEnv().GetCaseItemWidth();
	lvColumn.pszText = (char*) columnTitleCase.c_str();
	ListView_InsertColumn(listCtrl, INDEX_COLUMN_CHK_IS_CASE, &lvColumn);


	// CHK [hꗗ̃^Cgɖݒ肷
	SetChkWordListSortArrow(listCtrl);

	// ꗗ CHK [h̐ݒ肷
	ListView_SetItemCount(listCtrl, GetChkWordList().Count());


	//
	// Ώ
	//
	SET_CHECK(hWnd, GetChkAllCtrlId(), TRUE);


	//
	// CHK [h
	//

	// NOTE: ł邱ƂɒӁB
	//       Ƃ肠擾̍ۂ͔{ȏ̃obt@݂邱ƁB
	// CHK [h
	SendMessage(GetDlgItem(hWnd, GetChkWordCtrlId()), EM_SETLIMITTEXT, NUM_CHK_WORD_MAX, 0);
	// eXg
	SendMessage(GetDlgItem(hWnd, GetChkWordTestTargetCtrlId()), EM_SETLIMITTEXT, NUM_CHK_WORD_MAX, 0);


	//
	// ҏW{^
	//
	ENABLE_CHK_WORD_LIST_EDIT_BUTTONS(hWnd);

	return TRUE;
}

//----------------------------------------------------------------------
// WM_COMMAND nh
//----------------------------------------------------------------------

void CChkWordListDialogProc::OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify)
{
	if (idCtl == GetUseChkWordCtrlId()) {

		// CHK [hgp

		GetChkWordProfile().SetUseChkWord(IS_CHECKED(hWnd, GetUseChkWordCtrlId()));

	} else if (idCtl == GetChkWordTestCtrlId()) {

		// eXg

		std::string message;

		char chkword[NUM_CHK_WORD_MAX * 3] = "";

		// Ώۂ擾
		ChkWord::WordType wdType = ChkWord::ChkwAll;
		if (IS_CHECKED(hWnd, GetChkAllCtrlId())) {
			wdType = ChkWord::ChkwAll;
		} else if (IS_CHECKED(hWnd, GetChkSubjectCtrlId())) {
			wdType = ChkWord::ChkwSubject;
		} else if (IS_CHECKED(hWnd, GetChkFromnameCtrlId())) {
			wdType = ChkWord::ChkwFromname;
		}

		// CHK [h擾
		Edit_GetText(GetDlgItem(hWnd, GetChkWordCtrlId()), chkword, sizeof(chkword));

		std::string schkword = Util::Trim(chkword);

		// ͂Ă邩`FbN
		if (schkword.length() == 0) {
			message = CResourceManager::FormatResourceString(GetEnterChkWordMsgResId());
			MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
			SetFocus(GetDlgItem(hWnd, GetChkWordCtrlId()));
			return;
		}

		char testTarget[NUM_CHK_WORD_MAX * 3] = "";

		// eXg擾
		Edit_GetText(GetDlgItem(hWnd, GetChkWordTestTargetCtrlId()), testTarget, sizeof(testTarget));

		bool bError = false;
		std::string errorWhat = "";

		bool bMatch = Util::IsMatch(testTarget, schkword.c_str(), IS_CHECKED(hWnd, GetIsRegexCtrlId()), !IS_CHECKED(hWnd, GetIsCaseCtrlId()), bError, errorWhat);
		if (bMatch) {
			message = CResourceManager::FormatResourceString(GetTestMatchMsgResId());
			MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
		} else {
			if (bError) {
				message = CResourceManager::FormatResourceString(GetTestNotMatchAndErrorMsgResId(), errorWhat.c_str());
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONERROR);
			} else {
				message = CResourceManager::FormatResourceString(GetTestNotMatchMsgResId());
				MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONQUESTION);
			}
		}

		SetFocus(GetDlgItem(hWnd, GetChkWordTestTargetCtrlId()));

	} else if (idCtl == GetAddChkWordCtrlId()) {

		// ǉ

		std::string message;

		char chkword[NUM_CHK_WORD_MAX * 3] = "";

		// Ώۂ擾
		ChkWord::WordType wdType = ChkWord::ChkwAll;
		if (IS_CHECKED(hWnd, GetChkAllCtrlId())) {
			wdType = ChkWord::ChkwAll;
		} else if (IS_CHECKED(hWnd, GetChkSubjectCtrlId())) {
			wdType = ChkWord::ChkwSubject;
		} else if (IS_CHECKED(hWnd, GetChkFromnameCtrlId())) {
			wdType = ChkWord::ChkwFromname;
		}

		// CHK [h擾
		Edit_GetText(GetDlgItem(hWnd, GetChkWordCtrlId()), chkword, sizeof(chkword));

		std::string schkword = Util::Trim(chkword);

		// ͂Ă邩`FbN
		if (schkword.length() == 0) {
			message = CResourceManager::FormatResourceString(GetEnterChkWordMsgResId());
			MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
			SetFocus(GetDlgItem(hWnd, GetChkWordCtrlId()));
			return;
		}

		if (GetChkWordList().IsExist(schkword.c_str())) {
			message = CResourceManager::FormatResourceString(GetWordAlreadyRegisterdOrUpdateMsgResId());
			int rc = MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_YESNO | MB_ICONINFORMATION);
			if (rc != IDYES) {
				SetFocus(GetDlgItem(hWnd, GetChkWordCtrlId()));
				return;
			}

			// XV
			UpdateChkWord(hWnd, schkword.c_str(), wdType, IS_CHECKED(hWnd, GetIsRegexCtrlId()), IS_CHECKED(hWnd, GetIsCaseCtrlId()));
			return;
		}

		// o^
		AddChkWord(hWnd, schkword.c_str(), wdType, IS_CHECKED(hWnd, GetIsRegexCtrlId()), IS_CHECKED(hWnd, GetIsCaseCtrlId()));

	} else if (idCtl == GetUpdateChkWordCtrlId()) {

		// XV

		std::string message;

		char chkword[NUM_CHK_WORD_MAX * 3] = "";

		// Ώۂ擾
		ChkWord::WordType wdType = ChkWord::ChkwAll;
		if (IS_CHECKED(hWnd, GetChkAllCtrlId())) {
			wdType = ChkWord::ChkwAll;
		} else if (IS_CHECKED(hWnd, GetChkSubjectCtrlId())) {
			wdType = ChkWord::ChkwSubject;
		} else if (IS_CHECKED(hWnd, GetChkFromnameCtrlId())) {
			wdType = ChkWord::ChkwFromname;
		}

		// CHK [h擾
		Edit_GetText(GetDlgItem(hWnd, GetChkWordCtrlId()), chkword, sizeof(chkword));

		std::string schkword = Util::Trim(chkword);

		// ͂Ă邩`FbN
		if (schkword.length() == 0) {
			message = CResourceManager::FormatResourceString(GetEnterChkWordMsgResId());
			MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
			SetFocus(GetDlgItem(hWnd, GetChkWordCtrlId()));
			return;
		}

		if (!GetChkWordList().IsExist(schkword.c_str())) {
			message = CResourceManager::FormatResourceString(GetWordNotRegisterdOrAddMsgResId());
			int rc = MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_YESNO | MB_ICONINFORMATION);
			if (rc != IDYES) {
				SetFocus(GetDlgItem(hWnd, GetChkWordCtrlId()));
				return;
			}

			// ǉ
			AddChkWord(hWnd, schkword.c_str(), wdType, IS_CHECKED(hWnd, GetIsRegexCtrlId()), IS_CHECKED(hWnd, GetIsCaseCtrlId()));
			return;
		}

		// XV
		UpdateChkWord(hWnd, schkword.c_str(), wdType, IS_CHECKED(hWnd, GetIsRegexCtrlId()), IS_CHECKED(hWnd, GetIsCaseCtrlId()));

	} else if (idCtl == GetDelChkWordCtrlId()) {

		// 폜

		std::string message;

		HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());

		int index = ListView_GetNextItem(listCtrl, -1, LVNI_SELECTED);
		if (index < 0) {
			message = CResourceManager::FormatResourceString(GetChooseInTheListToDeleteChkWordMsgResId());
			MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);
			return;
		}

		DeleteChkWord(hWnd);

	} else if (idCtl == GetImportChkWordListCtrlId()) {

		// C|[g
		std::string strFilter = CResourceManager::FormatResourceString(GetImportChkWordListFileFilterResId());
		MAKE_OPENFILENAME_FILTER(&strFilter);
		std::string strTitle = CResourceManager::FormatResourceString(GetImportChkWordListTitleResId());

		char filepath[MAX_PATH * 4] = "";

		OPENFILENAME ofn;
		ZeroMemory(&ofn, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hWnd;
		ofn.lpstrFilter = strFilter.c_str();
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = filepath;
		ofn.nMaxFile = sizeof(filepath);
		ofn.lpstrTitle = strTitle.c_str();
		ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;

		BOOL rc = GetOpenFileName(&ofn);
		if (!rc) {
			return;
		}

		CWaitCursor waitCursor;

		GetChkWordList().Import(filepath);
		GetChkWordList().Sort();

		// ꗗɃAhX̐ݒ肷
		HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());
		ListView_SetItemCount(listCtrl, GetChkWordList().Count());

		InvalidateRect(listCtrl, 0, TRUE);

		ENABLE_CHK_WORD_LIST_EDIT_BUTTONS(hWnd);

		waitCursor.Restore();

		std::string message = CResourceManager::FormatResourceString(GetCompleteImportChkWordListMsgResId());
		MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);


	} else if (idCtl == GetExportChkWordListCtrlId()) {

		// GNX|[g

		SYSTEMTIME systime = { 0 };
		GetLocalTime(&systime);

		char filepath[MAX_PATH * 4];
		_snprintf(filepath, sizeof(filepath), GetExportChkWordListFormat(),
			systime.wYear,
			systime.wMonth,
			systime.wDay,
			systime.wHour,
			systime.wMinute,
			systime.wSecond
		);
		FORCE_ASCIZ(filepath);

		std::string strFilter = CResourceManager::FormatResourceString(GetExportChkWordListFileFilterResId());
		MAKE_OPENFILENAME_FILTER(&strFilter);
		std::string strTitle = CResourceManager::FormatResourceString(GetExportChkWordListTitleResId());
		std::string strDefExt = CResourceManager::FormatResourceString(GetExportChkWordListDefExtResId());

		OPENFILENAME ofn;
		ZeroMemory(&ofn, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.hwndOwner = hWnd;
		ofn.lpstrFilter = strFilter.c_str();
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = filepath;
		ofn.nMaxFile = sizeof(filepath);
		ofn.lpstrTitle = strTitle.c_str();
		ofn.Flags = OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
		ofn.lpstrDefExt = strDefExt.c_str();

		BOOL rc = GetSaveFileName(&ofn);
		if (!rc) {
			return;
		}

		CWaitCursor waitCursor;

		GetChkWordList().Export(filepath);

		waitCursor.Restore();

		std::string message = CResourceManager::FormatResourceString(GetCompleteExportChkWordListMsgResId());
		MessageBox(hWnd, message.c_str(), m_dlgCaption, MB_OK | MB_ICONINFORMATION);

	}
}

//----------------------------------------------------------------------
// WM_NOTIFY nh
//----------------------------------------------------------------------

BOOL CChkWordListDialogProc::OnNotify(HWND hWnd, int idCtrl, NMHDR* pnmhdr)
{
#define __FUNCNAME__ "CChkWordListDialogProc::OnNotify()"

	switch (pnmhdr->code) {
	case PSN_APPLY:
	case PSN_RESET:
		{
			//
			// uOKv{^܂́uLZv{^NbN̏
			//

			// ɐݒς݂Ȃ̂ŁuOKvɑ΂ĉȂB

			// ݒۑ
			GetChkWordProfileEnv().SetSortKey(GetChkWordList().GetSortKey());
			GetChkWordProfileEnv().SetAscending(GetChkWordList().IsAscending());

			HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());
			HWND listHdr = ListView_GetHeader(listCtrl);
			int itemCount = Header_GetItemCount(listHdr);
			for (int i = 0; i < itemCount; ++i) {

				HDITEM hdItem;
				ZeroMemory(&hdItem, sizeof(hdItem));

				// l擾
				hdItem.mask = HDI_WIDTH;
				Header_GetItem(listHdr, i, &hdItem);

				int width = hdItem.cxy;

				switch (i) {
				case INDEX_COLUMN_CHK_WORD_TYPE:
					GetChkWordProfileEnv().SetWordTypeItemWidth(width);
					break;
				case INDEX_COLUMN_CHK_WORD:
					GetChkWordProfileEnv().SetChkWordItemWidth(width);
					break;
				case INDEX_COLUMN_CHK_IS_REGEX:
					GetChkWordProfileEnv().SetRegexItemWidth(width);
					break;
				case INDEX_COLUMN_CHK_IS_CASE:
					GetChkWordProfileEnv().SetCaseItemWidth(width);
					break;
				}
			}
		}

		return TRUE;
	}

	if (pnmhdr->idFrom == GetChkWordListCtrlId()) {

		// CHK [hꗗ

		switch (pnmhdr->code) {
		case LVN_GETDISPINFO:
			{
				LV_DISPINFO* pDispInfo = (LV_DISPINFO*) pnmhdr;

				ChkWord& chkw = GetChkWordList().GetAt(pDispInfo->item.iItem);
				static std::string checkMark = CResourceManager::FormatResourceString(GetChkWordListCheckMarkResId());
				static std::string titleAll = CResourceManager::FormatResourceString(IDS_CHK_WORD_LIST_TITLE_ALL);
				static std::string titleSubject = CResourceManager::FormatResourceString(IDS_CHK_WORD_LIST_TITLE_SUBJECT);
				static std::string titleFromname = CResourceManager::FormatResourceString(IDS_CHK_WORD_LIST_TITLE_FROMNAME);

				switch (pDispInfo->item.iSubItem) {

				case INDEX_COLUMN_CHK_WORD_TYPE:
					if (pDispInfo->item.mask & LVIF_TEXT) {

						const char* title = "";
						switch (chkw.GetWordType()) {
						case ChkWord::ChkwAll:
						default:
							title = titleAll.c_str();
							break;
						case ChkWord::ChkwSubject:
							title = titleSubject.c_str();
							break;
						case ChkWord::ChkwFromname:
							title = titleFromname.c_str();
							break;
						}

						pDispInfo->item.pszText = (char*) title;
					}
					break;

				case INDEX_COLUMN_CHK_WORD:
					if (pDispInfo->item.mask & LVIF_TEXT) {
						pDispInfo->item.pszText = (char*) chkw.GetWord().c_str();
					}
					break;

				case INDEX_COLUMN_CHK_IS_REGEX:
					if (pDispInfo->item.mask & LVIF_TEXT) {
						pDispInfo->item.pszText = (chkw.IsRegex()) ? checkMark.c_str() : "";
					}
					break;

				case INDEX_COLUMN_CHK_IS_CASE:
					if (pDispInfo->item.mask & LVIF_TEXT) {
						pDispInfo->item.pszText = (chkw.IsCase()) ? checkMark.c_str() : "";
					}
					break;
				}
			}
			break;

		case LVN_COLUMNCLICK:
			{
				NMLISTVIEW* pnmlv = (NMLISTVIEW*) pnmhdr;

				HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());

				// ݑIĂ̂Ă
				std::string curchkword;

				int index = ListView_GetNextItem(listCtrl, -1, LVNI_SELECTED);
				if (0 <= index) {
					ChkWord& chkw = GetChkWordList().GetAt(index);
					curchkword = chkw.GetWord();
				}


				ChkWordList::SortKey sortKey = ChkWordList::SortChkwType;
				switch (pnmlv->iSubItem) {
				case INDEX_COLUMN_CHK_WORD_TYPE:
					sortKey = ChkWordList::SortChkwType;
					break;
				case INDEX_COLUMN_CHK_WORD:
					sortKey = ChkWordList::SortChkwWord;
					break;
				case INDEX_COLUMN_CHK_IS_REGEX:
					sortKey = ChkWordList::SortChkwRegex;
					break;
				case INDEX_COLUMN_CHK_IS_CASE:
					sortKey = ChkWordList::SortChkwCase;
					break;
				}

				if (GetChkWordList().GetSortKey() != sortKey) {
					// X\[gĂ鍀ڂƁAႤڂIꂽꍇ́AƂB
					GetChkWordList().SetAscending(true);
				} else {
					// ڂł΁AE~tɂB
					GetChkWordList().SetAscending(!GetChkWordList().IsAscending());
				}
				// \[gL[ݒ肷
				GetChkWordList().SetSortKey(sortKey);
				// \[g
				GetChkWordList().Sort();


				// CHK [hꗗ̃^Cgɖݒ肷
				SetChkWordListSortArrow(listCtrl);

				InvalidateRect(listCtrl, 0, TRUE);

				if (0 <= index) {
					index = GetChkWordList().GetIndex(curchkword.c_str());
					SELECT_LISTVIEW(listCtrl, index);
				}
			}
			break;

		case LVN_KEYDOWN:
			{
				// DEL L[Ƃ CHK [hꗗőIĂ̂폜
				NMLVKEYDOWN* plvKeyDown = (NMLVKEYDOWN*) pnmhdr;
				if (plvKeyDown->wVKey == VK_DELETE) {
					DeleteChkWord(hWnd);
					return TRUE;
				}
			}
			break;

		case NM_DBLCLK:
			{
				// _uNbNƂ CHK [hɈꗗ̒lݒ肷
				HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());

				int index = ListView_GetNextItem(listCtrl, -1, LVNI_SELECTED);
				if (index < 0) {
					return TRUE;
				}

				ChkWord& chkw = GetChkWordList().GetAt(index);

				SET_CHECK(hWnd, GetChkAllCtrlId(), chkw.GetWordType() == ChkWord::ChkwAll);
				SET_CHECK(hWnd, GetChkSubjectCtrlId(), chkw.GetWordType() == ChkWord::ChkwSubject);
				SET_CHECK(hWnd, GetChkFromnameCtrlId(), chkw.GetWordType() == ChkWord::ChkwFromname);

				Edit_SetText(GetDlgItem(hWnd, GetChkWordCtrlId()), chkw.GetWord().c_str());

				SET_CHECK(hWnd, GetIsRegexCtrlId(), chkw.IsRegex());
				SET_CHECK(hWnd, GetIsCaseCtrlId(), chkw.IsCase());
			}
			return TRUE;

		case LVN_ITEMCHANGED:
			{
				ENABLE_CHK_WORD_LIST_EDIT_BUTTONS(hWnd);
			}
			return TRUE;
		}

	}


	return FALSE;

#undef __FUNCNAME__
}

//----------------------------------------------------------------------
// CHK [h CHK [hꗗɒǉ
//----------------------------------------------------------------------

void CChkWordListDialogProc::AddChkWord(HWND hWnd, const char* chkword, const ChkWord::WordType wdType, const bool bRegex, const bool bCase)
{
	HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());

	GetChkWordList().Add(chkword, wdType, bRegex, bCase);
	GetChkWordList().Sort();
	ListView_SetItemCount(listCtrl, GetChkWordList().Count());
	InvalidateRect(listCtrl, 0, TRUE);

	int index = GetChkWordList().GetIndex(chkword);
	if (index < 0) {
		return;
	}

	SELECT_LISTVIEW(listCtrl, index);
}

//----------------------------------------------------------------------
// CHK [hꗗ CHK [hXV
//----------------------------------------------------------------------

void CChkWordListDialogProc::UpdateChkWord(HWND hWnd, const char* chkword, const ChkWord::WordType wdType, const bool bRegex, const bool bCase)
{
	HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());

	GetChkWordList().Update(chkword, wdType, bRegex, bCase);
	GetChkWordList().Sort();
	ListView_SetItemCount(listCtrl, GetChkWordList().Count());
	InvalidateRect(listCtrl, 0, TRUE);

	int index = GetChkWordList().GetIndex(chkword);
	if (index < 0) {
		return;
	}

	SELECT_LISTVIEW(listCtrl, index);
}

//----------------------------------------------------------------------
// CHK [hꗗ CHK [h폜
//----------------------------------------------------------------------

void CChkWordListDialogProc::DeleteChkWord(HWND hWnd)
{
	HWND listCtrl = GetDlgItem(hWnd, GetChkWordListCtrlId());

	int index = ListView_GetNextItem(listCtrl, -1, LVNI_SELECTED);
	if (index < 0) {
		return;
	}

	bool bDelete = GetChkWordList().DeleteAt(index);
	if (!bDelete) {
		return;
	}

	GetChkWordList().Sort();
	ListView_SetItemCount(listCtrl, GetChkWordList().Count());
	InvalidateRect(listCtrl, 0, TRUE);

	// 폜s̉̂̂I
	int count = GetChkWordList().Count();
	if (index < count) {
		SELECT_LISTVIEW(listCtrl, index);
	} else {
		int nextIndex = index - 1;
		if (0 <= nextIndex && nextIndex < count) {
			SELECT_LISTVIEW(listCtrl, nextIndex);
		}
	}

	ENABLE_CHK_WORD_LIST_EDIT_BUTTONS(hWnd);
}

//----------------------------------------------------------------------
// CHK [hꗗ̃^Cgɖݒ肷
//----------------------------------------------------------------------

void CChkWordListDialogProc::SetChkWordListSortArrow(HWND listCtrl)
{
	// ڂ̃CfbNX𓾂
	int columnIndex = INDEX_COLUMN_CHK_WORD_TYPE;
	switch (GetChkWordList().GetSortKey()) {
	case ChkWordList::SortChkwType:
		columnIndex = INDEX_COLUMN_CHK_WORD_TYPE;
		break;
	case ChkWordList::SortChkwWord:
		columnIndex = INDEX_COLUMN_CHK_WORD;
		break;
	case ChkWordList::SortChkwRegex:
		columnIndex = INDEX_COLUMN_CHK_IS_REGEX;
		break;
	case ChkWordList::SortChkwCase:
		columnIndex = INDEX_COLUMN_CHK_IS_CASE;
		break;
	}

	// ǂ𓾂
	bool bAscending = GetChkWordList().IsAscending();

	SetSortArrow(listCtrl, columnIndex, bAscending, m_bmUpArrow, m_bmDownArrow);
}

////////////////////////////////////////////////////////////////////////
// NG [h̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CNgWordListDialogProc::CNgWordListDialogProc(SettingDialogParam& param) :
	CChkWordListDialogProc(param)
{
}

//----------------------------------------------------------------------
// CHK [hgp ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetUseChkWordCtrlId()
{
	return IDC_CHK_USE_NG_WORD;
}

//----------------------------------------------------------------------
// CHK [hꗗ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordListCtrlId()
{
	return IDC_NG_WORD_LIST;
}

//----------------------------------------------------------------------
// ׂăWI{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkAllCtrlId()
{
	return IDC_RADIO_NG_ALL;
}

//----------------------------------------------------------------------
// WI{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkSubjectCtrlId()
{
	return IDC_RADIO_NG_SUBJECT;
}

//----------------------------------------------------------------------
// olWI{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkFromnameCtrlId()
{
	return IDC_RADIO_NG_FROMNAME;
}

//----------------------------------------------------------------------
// CHK [h ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordCtrlId()
{
	return IDC_NG_WORD;
}

//----------------------------------------------------------------------
// K\g̃`FbN{bNX ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetIsRegexCtrlId()
{
	return IDC_CHK_NG_USE_REGEX;
}

//----------------------------------------------------------------------
// 召ʂ̃`FbN{bNX ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetIsCaseCtrlId()
{
	return IDC_CHK_NG_CASE;
}

//----------------------------------------------------------------------
// eXgΏە ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordTestTargetCtrlId()
{
	return IDC_NG_WORD_TEST_TARGET;
}

//----------------------------------------------------------------------
// eXg{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordTestCtrlId()
{
	return IDC_NG_WORD_TEST;
}

//----------------------------------------------------------------------
// uΏہvڕ̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordListWordTypeTitleResId()
{
	return IDS_NG_WORD_LIST_COLUMN_WORD_TYPE;
}

//----------------------------------------------------------------------
// u[hvڕ̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordListChkWordTitleResId()
{
	return IDS_NG_WORD_LIST_COLUMN_NG_WORD;
}

//----------------------------------------------------------------------
// uK\vڕ̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordListIsRegexTitleResId()
{
	return IDS_NG_WORD_LIST_COLUMN_IS_REGEX;
}

//----------------------------------------------------------------------
// u召ʁvڕ̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordListIsCaseTitleResId()
{
	return IDS_NG_WORD_LIST_COLUMN_IS_CASE;
}

//----------------------------------------------------------------------
// ǉ{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetAddChkWordCtrlId()
{
	return IDC_ADD_NG_WORD;
}

//----------------------------------------------------------------------
// XV{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetUpdateChkWordCtrlId()
{
	return IDC_UPDATE_NG_WORD;
}

//----------------------------------------------------------------------
// 폜{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetDelChkWordCtrlId()
{
	return IDC_DEL_NG_WORD;
}

//----------------------------------------------------------------------
// C|[g{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetImportChkWordListCtrlId()
{
	return IDC_NG_WORD_IMPORT;
}

//----------------------------------------------------------------------
// GNX|[g{^ ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetExportChkWordListCtrlId()
{
	return IDC_NG_WORD_EXPORT;
}

//----------------------------------------------------------------------
// CHK [hė~|̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetEnterChkWordMsgResId()
{
	return IDS_MSG_ENTER_NG_WORD;
}

//----------------------------------------------------------------------
// eXgɃ}b`|̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetTestMatchMsgResId()
{
	return IDS_MSG_NG_WORD_TEST_MATCH;
}

//----------------------------------------------------------------------
// eXgɃ}b`Ȃ|̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetTestNotMatchMsgResId()
{
	return IDS_MSG_NG_WORD_TEST_NOT_MATCH;
}

//----------------------------------------------------------------------
// eXgɃ}b`G[o|̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetTestNotMatchAndErrorMsgResId()
{
	return IDS_MSG_NG_WORD_TEST_NOT_MATCH_AND_ERROR;
}

//----------------------------------------------------------------------
// łɓo^Ă̂ōXV邩̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetWordAlreadyRegisterdOrUpdateMsgResId()
{
	return IDS_MSG_NG_WORD_ALREADY_REGISTERED_OR_UPDATE;
}

//----------------------------------------------------------------------
// o^ĂȂ̂Œǉ邩̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetWordNotRegisterdOrAddMsgResId()
{
	return IDS_MSG_NG_WORD_NOT_REGISTERED_OR_ADD;
}

//----------------------------------------------------------------------
// 폜ɈꗗIĂȂꍇ̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChooseInTheListToDeleteChkWordMsgResId()
{
	return IDS_MSG_CHOOSE_IN_THE_LIST_TO_DELETE_NG_WORD;
}

//----------------------------------------------------------------------
// C|[g܂bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetCompleteImportChkWordListMsgResId()
{
	return IDS_MSG_COMPLETE_IMPORT_NG_WORD_LIST;
}

//----------------------------------------------------------------------
// GNX|[g܂bZ[W̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetCompleteExportChkWordListMsgResId()
{
	return IDS_MSG_COMPLETE_EXPORT_NG_WORD_LIST;
}

//----------------------------------------------------------------------
// C|[gtB^̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetImportChkWordListFileFilterResId()
{
	return IDS_IMPORT_NG_WORD_LIST_FILE_FILTER;
}

//----------------------------------------------------------------------
// C|[g^Cg̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetImportChkWordListTitleResId()
{
	return IDS_IMPORT_NG_WORD_LIST_TITLE;
}

//----------------------------------------------------------------------
// GNX|[gtB^̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetExportChkWordListFileFilterResId()
{
	return IDS_EXPORT_NG_WORD_LIST_FILE_FILTER;
}

//----------------------------------------------------------------------
// GNX|[g^Cg̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetExportChkWordListTitleResId()
{
	return IDS_EXPORT_NG_WORD_LIST_TITLE;
}

//----------------------------------------------------------------------
// GNX|[gftHggq̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetExportChkWordListDefExtResId()
{
	return IDS_EXPORT_NG_WORD_LIST_FILE_DEF_EXT;
}

//----------------------------------------------------------------------
// K\A召ʂ̃`FbN\̃\[X ID
//----------------------------------------------------------------------

int CNgWordListDialogProc::GetChkWordListCheckMarkResId()
{
	return IDS_NG_WORD_LIST_CHECK_MARK;
}

//----------------------------------------------------------------------
// GNX|[g̃t@CtH[}bg
//----------------------------------------------------------------------

char* CNgWordListDialogProc::GetExportChkWordListFormat()
{
	return "NgWordList_%04d%02d%02d_%02d%02d%02d.txt";
}

//----------------------------------------------------------------------
// ݒԂ
//----------------------------------------------------------------------

ChkWordProfile& CNgWordListDialogProc::GetChkWordProfile()
{
	return m_param.ngWordProfile;
}

//----------------------------------------------------------------------
// ݒ(p)Ԃ
//----------------------------------------------------------------------

ChkWordProfileEnv& CNgWordListDialogProc::GetChkWordProfileEnv()
{
	return m_param.ngWordProfileEnv;
}

//----------------------------------------------------------------------
// CHK [hꗗԂ
//----------------------------------------------------------------------

ChkWordList& CNgWordListDialogProc::GetChkWordList()
{
	return m_param.ngWordList;
}

////////////////////////////////////////////////////////////////////////
// OK [h̐ݒs_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

COkWordListDialogProc::COkWordListDialogProc(SettingDialogParam& param) :
	CChkWordListDialogProc(param)
{
}

//----------------------------------------------------------------------
// CHK [hgp ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetUseChkWordCtrlId()
{
	return IDC_CHK_USE_OK_WORD;
}

//----------------------------------------------------------------------
// CHK [hꗗ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordListCtrlId()
{
	return IDC_OK_WORD_LIST;
}

//----------------------------------------------------------------------
// ׂăWI{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkAllCtrlId()
{
	return IDC_RADIO_OK_ALL;
}

//----------------------------------------------------------------------
// WI{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkSubjectCtrlId()
{
	return IDC_RADIO_OK_SUBJECT;
}

//----------------------------------------------------------------------
// olWI{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkFromnameCtrlId()
{
	return IDC_RADIO_OK_FROMNAME;
}

//----------------------------------------------------------------------
// CHK [h ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordCtrlId()
{
	return IDC_OK_WORD;
}

//----------------------------------------------------------------------
// K\g̃`FbN{bNX ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetIsRegexCtrlId()
{
	return IDC_CHK_OK_USE_REGEX;
}

//----------------------------------------------------------------------
// 召ʂ̃`FbN{bNX ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetIsCaseCtrlId()
{
	return IDC_CHK_OK_CASE;
}

//----------------------------------------------------------------------
// eXgΏە ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordTestTargetCtrlId()
{
	return IDC_OK_WORD_TEST_TARGET;
}

//----------------------------------------------------------------------
// eXg{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordTestCtrlId()
{
	return IDC_OK_WORD_TEST;
}

//----------------------------------------------------------------------
// uΏہvڕ̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordListWordTypeTitleResId()
{
	return IDS_OK_WORD_LIST_COLUMN_WORD_TYPE;
}

//----------------------------------------------------------------------
// u[hvڕ̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordListChkWordTitleResId()
{
	return IDS_OK_WORD_LIST_COLUMN_OK_WORD;
}

//----------------------------------------------------------------------
// uK\vڕ̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordListIsRegexTitleResId()
{
	return IDS_OK_WORD_LIST_COLUMN_IS_REGEX;
}

//----------------------------------------------------------------------
// u召ʁvڕ̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordListIsCaseTitleResId()
{
	return IDS_OK_WORD_LIST_COLUMN_IS_CASE;
}

//----------------------------------------------------------------------
// ǉ{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetAddChkWordCtrlId()
{
	return IDC_ADD_OK_WORD;
}

//----------------------------------------------------------------------
// XV{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetUpdateChkWordCtrlId()
{
	return IDC_UPDATE_OK_WORD;
}

//----------------------------------------------------------------------
// 폜{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetDelChkWordCtrlId()
{
	return IDC_DEL_OK_WORD;
}

//----------------------------------------------------------------------
// C|[g{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetImportChkWordListCtrlId()
{
	return IDC_OK_WORD_IMPORT;
}

//----------------------------------------------------------------------
// GNX|[g{^ ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetExportChkWordListCtrlId()
{
	return IDC_OK_WORD_EXPORT;
}

//----------------------------------------------------------------------
// CHK [hė~|̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetEnterChkWordMsgResId()
{
	return IDS_MSG_ENTER_OK_WORD;
}

//----------------------------------------------------------------------
// eXgɃ}b`|̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetTestMatchMsgResId()
{
	return IDS_MSG_OK_WORD_TEST_MATCH;
}

//----------------------------------------------------------------------
// eXgɃ}b`Ȃ|̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetTestNotMatchMsgResId()
{
	return IDS_MSG_OK_WORD_TEST_NOT_MATCH;
}

//----------------------------------------------------------------------
// eXgɃ}b`G[o|̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetTestNotMatchAndErrorMsgResId()
{
	return IDS_MSG_OK_WORD_TEST_NOT_MATCH_AND_ERROR;
}

//----------------------------------------------------------------------
// łɓo^Ă̂ōXV邩̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetWordAlreadyRegisterdOrUpdateMsgResId()
{
	return IDS_MSG_OK_WORD_ALREADY_REGISTERED_OR_UPDATE;
}

//----------------------------------------------------------------------
// o^ĂȂ̂Œǉ邩̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetWordNotRegisterdOrAddMsgResId()
{
	return IDS_MSG_OK_WORD_NOT_REGISTERED_OR_ADD;
}

//----------------------------------------------------------------------
// 폜ɈꗗIĂȂꍇ̃bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChooseInTheListToDeleteChkWordMsgResId()
{
	return IDS_MSG_CHOOSE_IN_THE_LIST_TO_DELETE_OK_WORD;
}

//----------------------------------------------------------------------
// C|[g܂bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetCompleteImportChkWordListMsgResId()
{
	return IDS_MSG_COMPLETE_IMPORT_OK_WORD_LIST;
}

//----------------------------------------------------------------------
// GNX|[g܂bZ[W̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetCompleteExportChkWordListMsgResId()
{
	return IDS_MSG_COMPLETE_EXPORT_OK_WORD_LIST;
}

//----------------------------------------------------------------------
// C|[gtB^̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetImportChkWordListFileFilterResId()
{
	return IDS_IMPORT_OK_WORD_LIST_FILE_FILTER;
}

//----------------------------------------------------------------------
// C|[g^Cg̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetImportChkWordListTitleResId()
{
	return IDS_IMPORT_OK_WORD_LIST_TITLE;
}

//----------------------------------------------------------------------
// GNX|[gtB^̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetExportChkWordListFileFilterResId()
{
	return IDS_EXPORT_OK_WORD_LIST_FILE_FILTER;
}

//----------------------------------------------------------------------
// GNX|[g^Cg̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetExportChkWordListTitleResId()
{
	return IDS_EXPORT_OK_WORD_LIST_TITLE;
}

//----------------------------------------------------------------------
// GNX|[gftHggq̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetExportChkWordListDefExtResId()
{
	return IDS_EXPORT_OK_WORD_LIST_FILE_DEF_EXT;
}

//----------------------------------------------------------------------
// K\A召ʂ̃`FbN\̃\[X ID
//----------------------------------------------------------------------

int COkWordListDialogProc::GetChkWordListCheckMarkResId()
{
	return IDS_OK_WORD_LIST_CHECK_MARK;
}

//----------------------------------------------------------------------
// GNX|[g̃t@CtH[}bg
//----------------------------------------------------------------------

char* COkWordListDialogProc::GetExportChkWordListFormat()
{
	return "OkWordList_%04d%02d%02d_%02d%02d%02d.txt";
}

//----------------------------------------------------------------------
// ݒԂ
//----------------------------------------------------------------------

ChkWordProfile& COkWordListDialogProc::GetChkWordProfile()
{
	return m_param.okWordProfile;
}

//----------------------------------------------------------------------
// ݒ(p)Ԃ
//----------------------------------------------------------------------

ChkWordProfileEnv& COkWordListDialogProc::GetChkWordProfileEnv()
{
	return m_param.okWordProfileEnv;
}

//----------------------------------------------------------------------
// CHK [hꗗԂ
//----------------------------------------------------------------------

ChkWordList& COkWordListDialogProc::GetChkWordList()
{
	return m_param.okWordList;
}

////////////////////////////////////////////////////////////////////////
// uӎṽ_CAOvV[W̋@\
////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CThanksDialogProc::CThanksDialogProc(SettingDialogParam& param) :
	m_param(param)
{
	m_dlgCaption[0] = '\0';
}

//----------------------------------------------------------------------
// uӎṽ_CAOvV[W
//----------------------------------------------------------------------

BOOL CThanksDialogProc::DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_MSG(hWnd, WM_INITDIALOG, OnInitDialog);
	HANDLE_MSG(hWnd, WM_NOTIFY, OnNotify);
	}

	return FALSE;
}

//----------------------------------------------------------------------
// WM_INITDIALOG nh
//----------------------------------------------------------------------

BOOL CThanksDialogProc::OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	//
	// s
	//

	// _CAÕ^Cg擾Ă
	GetWindowText(hWnd, m_dlgCaption, sizeof(m_dlgCaption));

	// ݒ肷
	std::string thanks = CResourceManager::FormatResourceString(IDS_THANKS);
	SetWindowText(GetDlgItem(hWnd, IDC_EDIT_THANKS), thanks.c_str());

	return TRUE;
}

//----------------------------------------------------------------------
// WM_NOTIFY nh
//----------------------------------------------------------------------

BOOL CThanksDialogProc::OnNotify(HWND hWnd, int idCtrl, NMHDR* pnmhdr)
{
	switch (pnmhdr->code) {
	case PSN_APPLY:
		{
			//
			// uOKv{^NbN̏
			//

			// ȂB
		}
		return TRUE;
	}

	return FALSE;
}

////////////////////////////////////////////////////////////////////////
// ݒ_CAO
////////////////////////////////////////////////////////////////////////

// g̃CX^X
CSettingDialog* CSettingDialog::s_pThis;

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CSettingDialog::CSettingDialog(SettingDialogParam& param) :
	m_bkBsfilSettingDialogProc(param),
	m_otherSettingDialogProc(param),
	m_whiteListDialogProc(param),
	m_ngWordListDialogProc(param),
	m_okWordListDialogProc(param),
	m_thanksDialogProc(param),
	m_param(param)
{
	// NOTE: !!!!!!!!!!
	//       CSettingDialog ̃CX^Xx 2 ȏg
	//       낵ƂɂȂB
	s_pThis = this;
}

//----------------------------------------------------------------------
// BkBsfilWrapper ̐ݒs_CAOvV[W
//----------------------------------------------------------------------

BOOL CALLBACK CSettingDialog::BkBsfilSettingDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->m_bkBsfilSettingDialogProc.DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// ̑̐ݒs_CAOvV[W
//----------------------------------------------------------------------

BOOL CALLBACK CSettingDialog::OtherSettingDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->m_otherSettingDialogProc.DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// zCgXg̐ݒs_CAOvV[W
//----------------------------------------------------------------------

BOOL CALLBACK CSettingDialog::WhiteListDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->m_whiteListDialogProc.DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// NG [h̐ݒs_CAOvV[W
//----------------------------------------------------------------------

BOOL CALLBACK CSettingDialog::NgWordListDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->m_ngWordListDialogProc.DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// NG [h̐ݒs_CAOvV[W
//----------------------------------------------------------------------

BOOL CALLBACK CSettingDialog::OkWordListDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->m_okWordListDialogProc.DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// uӎṽ_CAOvV[W
//----------------------------------------------------------------------

BOOL CALLBACK CSettingDialog::ThanksDialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->m_thanksDialogProc.DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// \
//----------------------------------------------------------------------

int CSettingDialog::DoModal(HWND hWndParent)
{
	LPCTSTR lpTemplate;

	HPROPSHEETPAGE hPsp[6];
	ZeroMemory(&hPsp, sizeof(hPsp));

	PROPSHEETPAGE psp;

	// BkBsfilWrapper ̐ݒs_CAO
	ZeroMemory(&psp, sizeof(psp));
	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT;
	lpTemplate = MAKEINTRESOURCE(IDD_DLG_SETTING);
	psp.hInstance = CResourceManager::GetDialogInstanceHandle(lpTemplate);
	psp.pszTemplate = lpTemplate;
	psp.pfnDlgProc = (DLGPROC) BkBsfilSettingDialogProc;
	hPsp[0] = CreatePropertySheetPage(&psp);

	// ̑̐ݒs_CAO
	ZeroMemory(&psp, sizeof(psp));
	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT;
	lpTemplate = MAKEINTRESOURCE(IDD_DLG_OTHER_SETTING);
	psp.hInstance = CResourceManager::GetDialogInstanceHandle(lpTemplate);
	psp.pszTemplate = lpTemplate;
	psp.pfnDlgProc = (DLGPROC) OtherSettingDialogProc;
	hPsp[1] = CreatePropertySheetPage(&psp);

	// zCgXg̐ݒs_CAO
	ZeroMemory(&psp, sizeof(psp));
	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT;
	lpTemplate = MAKEINTRESOURCE(IDD_DLG_WHITELIST);
	psp.hInstance = CResourceManager::GetDialogInstanceHandle(lpTemplate);
	psp.pszTemplate = lpTemplate;
	psp.pfnDlgProc = (DLGPROC) WhiteListDialogProc;
	hPsp[2] = CreatePropertySheetPage(&psp);

	// OK [h̐ݒs_CAOvV[W
	ZeroMemory(&psp, sizeof(psp));
	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT;
	lpTemplate = MAKEINTRESOURCE(IDD_DLG_OK_WORD);
	psp.hInstance = CResourceManager::GetDialogInstanceHandle(lpTemplate);
	psp.pszTemplate = lpTemplate;
	psp.pfnDlgProc = (DLGPROC) OkWordListDialogProc;
	hPsp[3] = CreatePropertySheetPage(&psp);

	// NG [h̐ݒs_CAOvV[W
	ZeroMemory(&psp, sizeof(psp));
	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT;
	lpTemplate = MAKEINTRESOURCE(IDD_DLG_NG_WORD);
	psp.hInstance = CResourceManager::GetDialogInstanceHandle(lpTemplate);
	psp.pszTemplate = lpTemplate;
	psp.pfnDlgProc = (DLGPROC) NgWordListDialogProc;
	hPsp[4] = CreatePropertySheetPage(&psp);

	// uӎṽ_CAO
	ZeroMemory(&psp, sizeof(psp));
	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT;
	lpTemplate = MAKEINTRESOURCE(IDD_DLG_THANKS);
	psp.hInstance = CResourceManager::GetDialogInstanceHandle(lpTemplate);
	psp.pszTemplate = lpTemplate;
	psp.pfnDlgProc = (DLGPROC) ThanksDialogProc;
	hPsp[5] = CreatePropertySheetPage(&psp);



	// o[W擾
	CFileVersionInfo fvi(CResourceManager::GetMainInstance());
	std::string productVersion = fvi.GetProductVersion();

	// LvV
	std::string propCaption = CResourceManager::FormatResourceString(IDS_BKBSFILWRAPPER_PROP_TITLE,
			productVersion.c_str()
		);

	PROPSHEETHEADER psh;
	ZeroMemory(&psh, sizeof(psh));
	psh.dwSize = sizeof(PROPSHEETHEADER);
	psh.dwFlags = PSH_NOAPPLYNOW | PSH_NOCONTEXTHELP;
	psh.hwndParent = hWndParent;
	psh.pszCaption = propCaption.c_str();
	psh.nPages = sizeof(hPsp)/sizeof(hPsp[0]);
	psh.phpage = hPsp;


	return PropertySheet(&psh);
}
